## BioSAK (A Swiss-Army-Knife for Bioinformaticians)

[![pypi licence ](https://img.shields.io/pypi/l/BioSAK.svg)](https://opensource.org/licenses/gpl-3.0.html)
[![pypi version ](https://img.shields.io/pypi/v/BioSAK.svg)](https://pypi.python.org/pypi/BioSAK) 
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.4070001.svg)](https://doi.org/10.5281/zenodo.4070001)


Contact
---

Shan Zhang ([link](https://www.pharma.hku.hk/en/Our-People/Professoriate-Staff/Research-Assistant-Professor/Shan-ZHANG/Shan-ZHANG-Profile))<sup>1</sup> and Weizhi Song ([link](https://facultyprofiles.hkust.edu.hk/profiles.php?profile=weizhi-song-ocessongwz))<sup>2</sup>

<sup>1</sup> Department of Pharmacology and Pharmacy, LKS Faculty of Medicine, The University of Hong Kong, Hong Kong

<sup>2</sup> Department of Ocean Science, Hong Kong University of Science and Technology, Hong Kong


Installation
---

+ BioSAK has been tested on Linux/Mac, but **NOT** yet on Windows.


+ BioSAK is implemented in python3, you can

  + install it with `pip3 install BioSAK`
  
  + upgrade it with `pip3 install --upgrade BioSAK`


+ If you are an UNSW [Katana](https://research.unsw.edu.au/katana) user, [this](doc/katana.md) might be helpful.


 Getting help
---

+ You can get the help information and example commands by typing `BioSAK [module name] -h`, for example:
    
      BioSAK iTOL -h
      BioSAK select_seq -h
      BioSAK get_GTDB_taxon_gnm -h


[//]: # (+ **中文版**帮助文件[在此]&#40;doc/Index_cn.md&#41;.)


+ A license statement is [here](LICENSE).


+ A changelog is [here](BioSAK/VERSION).


BioSAK modules
---


+ Type `BioSAK -h` to see a full list of modules


                         ...::: BioSAK v1.127.0 :::...
        Databases
           get_GTDB_taxon_gnm      ->  Get id of genomes from specified GTDB taxons
           get_genome_GTDB         ->  Batch download GTDB genomes
           get_genome_NCBI         ->  Batch download GenBank genomes
           sampling_GTDB_gnms      ->  Select GTDB genomes
           subset_GTDB_meta        ->  Subset metadata of GTDB reference genomes
           metaAssembly            ->  Get metadata of NCBI assembly records
           metaBiosample           ->  Get metadata of NCBI biosample records
           sra2biosample           ->  Get Biosample Id of SRA record
           statsTaxa               ->  stats GTDB taxa
           GenBank                 ->  get sequence/organism/voucher info
           sra                     ->  Download reads with sratoolkit
           FasterqDump             ->  A wrapper for fasterq-dump
           get_Pfam_hmms           ->  Get Pfam profiles by id
           taxdump                 ->  Parse NCBI Taxonomy database
    
        Metagenomics
           metabat2concoct         ->  convert MetaBAT depth to CONCOCT depth
           metabat2maxbin          ->  convert MetaBAT depth to MaxBin depth
           CheckM                  ->  Parse CheckM outputs
           Plot_MAG                ->  plot MAGs, (GC vs depth)
           magabund                ->  Calculate MAG abundance
           mean_MAG_cov            ->  Get mean MAG depth (by MetaBAT depth)
           RunGraphMB              ->  Prepare input files for GraphMB
           gc                      ->  Get GC content
           get_gnm_size            ->  Get the total length of genome(s)
           get_gene_depth          ->  Get gene depth by contig depth
           MeanMappingDepth        ->  Get mean mapping depth 
           get_MAG_reads_long      ->  Extract MAG-specific long reads for reassembling
           mmseqs                  ->  Classify metagenomic contigs with mmseqs
           parse_mmseqs_tsv        ->  Parse mmseqs tsv
           fastaai                 ->  A wrapper for FastAAI
           abd                     ->  get MAG abundance across metagenomes (Wenxiu Wang et al. 2024)
           abd_mask                ->  prepare masked sequence for abd module
           cdb                     ->  reformat dRep Cdb file
           
        Functional annotation
           KEGG                    ->  KEGG annotation
           koala                   ->  Separate the combined BlastKOALA or GhostKOALA output
           COG2020                 ->  COG annotation (v2020, by blastp/diamond)
           COG2024                 ->  COG annotation (v2024, by blastp/diamond)
           arCOG                   ->  COG annotation for archaea (version ar18)
           dbCAN                   ->  CAZy annotation with dbCAN
           Combine_KEGG_arCOG      ->  Combine KEGG and arCOG annotation results
           Combine_KEGG_COG        ->  Combine KEGG and COG annotation results
           enrich                  ->  Functional enrichment analysis
           gapseq                  ->  Data matrix GapSeq predicted pathways
           stats_ko                ->  get stats for a list of provided KO
           stats_arcog             ->  get stats for a list of provided arCOG 
           stats_cog2024           ->  get stats for a list of provided COG (v2024)
           combine_fun_stats       ->  combine outputs from stats_ko, stats_arcog or stats_cog2024
            
        16S rRNA related
           blca                    ->  Classify 16S with BLCA
           SILVA_for_BLCA          ->  Prepare BLCA-compatible SILVA SSU database
           GTDB_for_BLCA           ->  Prepare BLCA-compatible GTDB SSU database
           UNITE_for_BLCA          ->  Prepare BLCA-compatible UNITE SSU database
           BLCA_op_parser          ->  Make the BLCA outputs bit easier to read
           top_16S_hits            ->  Classify 16S by top-blast-hits approach
           Tax4Fun2IndOTU          ->  Get functional profile for individual OTUs (to be added)
           get_eu_otu              ->  Get eukaryotic OTUs
           rm_low_abd_otu          ->  Remove low abd otu from table
           combine_low_abd_otu     ->  Combine low abundance OTUs
           rm_low_depth_sample     ->  Remove samples from OTU table with small number of sequences
           Usearch16S              ->  Usearch for Novogene 16S amplicon sequencing results
    
        Sequence/reads manipulator
           gbk2fna/gbk2faa/gbk2ffn ->  Format convertors
           ffn2faa/gfa2fa/get_rc   ->  Format convertors
           fq2fa                   ->  Convert fastq to fasta
           fa2id                   ->  Export sequence id
           slice_seq               ->  Get specified region of a sequence
           rename_seq              ->  Rename sequences in a file
           prefix_seq_by_file_name ->  prefix sequences by file name
           select_seq              ->  Select sequences by id
           split_fasta             ->  Split one fasta file into multiple files
           merge_seq               ->  Merge sequence files, remove duplicated ones if any
           cat_fa                  ->  Combine fasta files, prefix sequence id with file name
           subset_gene_by_gnm      ->  Subset gene by genome
           rm_desc                 ->  Remove sequence descriptions
           rm_short                ->  Remove short sequences
           Reads_simulator         ->  Simulate NGS reads
           SubsampleLongReads      ->  Subsample Long Reads
           rename_reads_Reago      ->  Rename paired reads for Reago
           trim                    ->  A wrapper for trimmomatic
    
        Sam and Bam
           reads2bam               ->  Mapping and sorting
           sam2bam                 ->  Sam to BAM with samtools
           split_sam               ->  Split SAM/BAM file by reference
           bam2reads               ->  Extract reads (id) from sam file
           plot_sam_depth          ->  Plot SAM depth
        
        Dataframe and Statistics
           subset_df               ->  Subset dataframe
           merge_df                ->  Merge dataframes
           add_desc                ->  Add function description to input of the iTOL module
           transpose               ->  Transpose dataframe
           wilcox                  ->  Wilcoxon signed-rank test (non-parametric paired T-test)
           mannwhitneyu            ->  Mann-Whitney U rank test on two independent samples
           rename_df_row           ->  Rename row headers in a dataframe
        
        Files and folders
           compare                 ->  compare sets
           split_folder            ->  Split folder
           prefix_file             ->  Prefix file
           KeepRemovingTmp         ->  Keep removing old files in a folder
        
        HPC related
           js_cmds                 ->  Put commands in job scripts
           exe_cmds                ->  Execute commands with multiprocessing
           submitHPC               ->  A wrapper for submitHPC.sh
           srun                    ->  srun one-line commands on HKUST hpc3
           js_hpc3                 ->  Put commands in job scripts (HKUST hpc3)
           hpc4                    ->  Submit jobs on HKUST hpc4
    
        Diagram and visualization
           VisGeneFlk              ->  Visualize gene flanking regions
           ribbon                  ->  Make a ribbon diagram
           sankey                  ->  get sankey plot
           cross_link_seqs         ->  Cross link matched regions between two sequences
           vis_color_scheme        ->  Visualize color scheme
           get_single_page_web     ->  Get single page website
              
        Others
           blast                   ->  Parse batch online blast output
           BestHit                 ->  Keep best blast hits (outfmt 6)
           usearch_uc              ->  Parse Usearch uc file
           metadata                ->  Update metadata file

Here are some of my frequently used functions
---

+ [sep_path_name_ext](sep_path_name_ext.py)
+ [number](number.py)
+ [list_and_dict](list_and_dict.py.py)
+ [get file/folder list](file_and_folder.py)
+ [check_executables](check_executables.py)
+ [multiprocessing](multiprocessing.py)
+ [argparse](argparse.py)
+ [index columns](index_columns.py)

+ Tax4Fun2 was developed by Dr Bernd Wemheuer.
+ [This](Tax4Fun2_example_cmds.R) is a short R script showing how it can be installed and executed for functional prediction.
+ https://environmentalmicrobiome.biomedcentral.com/articles/10.1186/s40793-020-00358-7

### Download GenBank genomes

   1. Go to https://www.ncbi.nlm.nih.gov/genome/browse#!/prokaryotes/refseq_category:reference
   
   1. Search genomes you want to download (e.g. Alteromonas, Archaea)
   
   1. Save search results by clicking the "Download" icon.
   ![demo](Demo_batch_download_GenBank_genomes.png)

   1. Download genomes with `BioSAK dwnld_GenBank_genome`
    
          cd /srv/scratch/$zID/BioSAK_demo/OtherFiles
          BioSAK dwnld_GenBank_genome -csv prokaryotes.csv -fna -name

## Tree visualization with [iTOL](https://itol.embl.de)

1. Here, I have a phylogenetic tree for 37 MAGs derived from six microbial communities (either surface-associated or planktonic) sampled in the North Sea.
I have the taxonomy info of these MAGs at the class level, their sizes and their abundances across the six samples.
This short note shows how to visualize all these info in one plot.

1. Download files: [files_needed.zip](files_needed.zip)

1. File description (Please see below for how to prepare these files.):

    + A phylogenetic tree in [Newick](http://evolution.genetics.washington.edu/phylip/newicktree.html) format: [NorthSea_0_Tree.newick](files_needed/NorthSea_0_Tree.newick)
    + Taxonomy info: [NorthSea_1_Taxon_ColorStrip.txt](files_needed/NorthSea_1_Taxon_ColorStrip.txt), [NorthSea_1_Taxon_Range.txt](files_needed/NorthSea_1_Taxon_Range.txt)
    + Life-style info: [NorthSea_2_LifeStyle.txt](files_needed/NorthSea_2_LifeStyle.txt)
    + Abundance across samples: [NorthSea_3_Abundance.txt](files_needed/NorthSea_3_Abundance.txt)
    + MAG size info: [NorthSea_4_MAG_Size.txt](files_needed/NorthSea_4_MAG_Size.txt)

1. Upload **NorthSea_0_Tree.newick** to iTOL via [https://itol.embl.de/upload.cgi](https://itol.embl.de/upload.cgi).

1. Once you have the tree uploaded, you'll see the skeleton of the tree without any decoration. 
You can now play around with the control panel on the right side (e.g. change tree layout to circular).
![Step_1](figures/Step_1.jpg)

1. We are going to add the taxonomy info of our MAG to the tree now, which is really easy to do in iTOL. 
You just need to drag and drop **NorthSea_1_Taxon_ColorStrip.txt**  to the **tree area**.

1. Do the same thing to **NorthSea_2_LifeStyle.txt**, **NorthSea_3_Abundance.txt** and **NorthSea_4_MAG_Size.txt** to add life-style, abundance and size info, 
you'll see trees like this:
![Tree_1](figures/Tree_1.jpg)

1. To get a tree with a circular layout and MAG classes coloured as in the figure below. 
You need to use **NorthSea_1_Taxon_Range.txt** instead of **NorthSea_1_Taxon_ColorStrip.txt**,
choose "**Circular**" mode in the control panel, click "**At tips**" and then turn it **off**.
![Tree_2](figures/Tree_2.jpg)

1. Go to the **Export** panel, choose desired file format and export your tree to file. 
Remember to turn on **Colored ranges legend**, if you are using **NorthSea_1_Taxon_Range.txt** to color MAG classes.
![Step_2](figures/Step_2.jpg)


# How to prepare these files

+ Some tools suggested by iTOL: https://itol.embl.de/help.cgi#external

+ You can also use [BioSAK](https://github.com/songweizhi/BioSAK)'s iTOL module to prepare these files. Please refers to the [help page](https://github.com/songweizhi/BioSAK) for its installation.
    
  The purpose for developing this module is to generate iTOL-recognizable file for your dataset, 
  parameters (e.g. colour, font size and strip width) provided in the output file might need 
  further adjustment. The best way to optimize your plot is to visualize your tree with the 
  default output and optimize the parameters by looking at the tree.
  
  Input files for the following commands can be found in `files_needed/raw_data`.
     
      BioSAK iTOL -ColorRange -lg raw_MAG_taxon.txt -lt Class -out NorthSea_1_Taxon_Range.txt
      BioSAK iTOL -ColorStrip -lg raw_MAG_taxon.txt -lt Class -out NorthSea_1_Taxon_ColorStrip.txt
      BioSAK iTOL -ColorStrip -lg raw_MAG_LifeStyle.txt -lt LifeStyle -out NorthSea_2_LifeStyle.txt
      BioSAK iTOL -Heatmap -lm raw_MAG_abundance.txt -lt Abundance -out NorthSea_3_Abundance.txt
      BioSAK iTOL -SimpleBar -lv raw_MAG_size.txt -scale 0-3-6-9 -lt MAG_Size -out NorthSea_4_MAG_Size.txt
      
      # for help
      BioSAK iTOL -h


# Help information

1. More examples: [https://itol.embl.de/help.cgi](https://itol.embl.de/help.cgi)
1. The Newick tree format: [http://evolution.genetics.washington.edu/phylip/newicktree.html](http://evolution.genetics.washington.edu/phylip/newicktree.html)
1. Hex Color Codes: [https://htmlcolorcodes.com](https://htmlcolorcodes.com) and [https://www.color-hex.com](https://www.color-hex.com)

##These are my plot examples in R
###Circlize_demo
![](Circlize_demo.png)

###googleVis
![](googleVis.jpg)

###heatmap_plotrix
![](heatmap_plotrix.png)

###heatmap_ploty
![](heatmap_ploty_1.png)

###heatmap_ploty
![](heatmap_ploty_2.png)

###plot_ggplot2
![](plot_ggplot2_1.png)

###plot_ggplot2
![](plot_ggplot2_2.png)

###plot_ggplot2
![](plot_ggplot2_3.png)

###VennDiagram
![](VennDiagram.png)

![logo](images/TCG_logo.jpg)


Taxonomy classification based on GTDB (http://gtdb.ecogenomic.org)
---
+ Contact: Weizhi Song (songwz03@gmail.com)
+ Affiliation: The Centre for Marine Bio-Innovation (CMB), The University of New South Wales, Sydney, Australia

Dependencies
---

+ [BioPython](https://github.com/biopython/biopython.github.io/)
+ [BLAST+](https://blast.ncbi.nlm.nih.gov/Blast.cgi?PAGE_TYPE=BlastDocs&DOC_TYPE=Download)
+ [HMMER](http://hmmer.org)
+ [KronaTools](https://github.com/marbl/Krona/wiki)
+ [Genome Taxonomy Database (GTDB)](http://gtdb.ecogenomic.org)

Change Log
---
None


Help information
---

!!! Note !!!

1. TCG only support the classification of bacterial genomes so far, the classification for Archaeal genomes will be supported after their corresponding db files are available for download from GTDB (http://gtdb.ecogenomic.org/downloads).

1. It takes about 40 seconds for the process of each query genome.


        python3 TCG.py -h

        arguments:
          -i                    folder holds the annotation file of input genomes
          -c                    confidence level (must higher than 50), default: 80
          -tuning               tuning mode
          -bac120hmm            path to bac120.HMM
          -blastdb              path to blast db folder: bac120_msa_individual_genes_r83
          -taxondb              path to file: taxonomy_r83.tsv
          -hmmsearch            path to hmmsearch, default: hmmsearch
          -blastp               path to blastp, default: blastp
          -ktImportText         path to ktImportText (from KronaTools), default: ktImportText


Prepare database files
---

        # Create a folder wherever you want to hold GTDB database files
        $ mkdir TCG_GTDB
        $ cd TCG_GTDB

        # download hmm profiles of the 120 bacterial marker genes
        $ wget https://raw.githubusercontent.com/songweizhi/TCG/master/db_files/bac120.HMM.gz
        $ gzip -d bac120.HMM.gz

        # Download bac_taxonomy_r83.tsv from GTDB
        $ wget https://data.ace.uq.edu.au/public/gtdb/release83/bac_taxonomy_r83.tsv

        # Download bac120_msa_individual_genes_r83.tar.gz from GTDB and unzip it
        $ wget https://data.ace.uq.edu.au/public/gtdb/release83/bac120_msa_individual_genes_r83.tar.gz
        $ mkdir bac120_msa_individual_genes_r83
        $ tar -xzvf bac120_msa_individual_genes_r83.tar.gz -C bac120_msa_individual_genes_r83

        # get blast database
        $ python path/to/get_db.py -in bac120_msa_individual_genes_r83

        # The generated blast databases are in bac120_msa_individual_genes_r83_db


Input files and arguments
---
You may want to try with different confidence levels after the first run. By specifying the '-tuning' option, TCG will skip the blast step and read in blast results from the last ran.

        # first run with a confidence level of 80%
        $ python TCG.py -bac120hmm path/to/bac120.HMM -blastdb path/to/bac120_msa_individual_genes_r83_db -taxondb path/to/bac_taxonomy_r83.tsv -i human_gut_bins -c 80

        # you may want to try with a different confidence level (e.g. 90%)
        $ python TCG.py -bac120hmm path/to/bac120.HMM -blastdb path/to/bac120_msa_individual_genes_r83_db -taxondb path/to/bac_taxonomy_r83.tsv -i human_gut_bins -c 90 -tuning

Output files
---

1. Taxonomy classification for each query genome

        Genome	Assignment	Confidence_level(%)
        bin349	o__RF39	86.73
        bin358	o__RF39	88.39
        bin388	g__Zag111	95.41
        bin372	g__CAG-710	89.72
        bin342	g__CAG-552	91.3
        bin399	g__CAG-914	82.57
        bin98	s__PeH17 sp1	85.98
        bin325	c__Clostridia	81.19
        bin333	c__Bacteroidia	80.43
        bin335	p__Firmicutes	80.68
        bin417	g__Bacteroides_A	88.7
        bin799	f__Ruminococcaceae	80.0
        bin80	p__Proteobacteria	80.19

1. Visualization with Krona plot

    ![Krona_plot](images/Krona_plot.png)

Example plots in python.
------

1. Basic barplot [[basic_plot.py](basic_plot.py)]
   ![basic_barplot](basic_barplot.png)

1. Boxplot with dots [[basic_plot.py](basic_plot.py)]
   ![boxplot_with_dots.png](boxplot_with_dots.png)

1. Boxplot with extra values [[Boxplot_with_extra_values.py](Boxplot_with_extra_values.py)]
   ![Boxplot_with_extra_values.png](Boxplot_with_extra_values.png)

1. Grouped boxplot [[grouped_boxplot.py](grouped_boxplot.py)]
   ![grouped_boxplot.png](grouped_boxplot.png)

1. Grouped boxplot with extra values [[Grouped_boxplot_with_extra_values.py](Grouped_boxplot_with_extra_values.py)]
   ![Grouped_boxplot_with_extra_values.png](Grouped_boxplot_with_extra_values.png)

1. Categorical scatter plot [[basic_plot.py](basic_plot.py)]
   ![categorical_scatter_plot.png](categorical_scatter_plot.png)

1. Customize subplots [[customized_subplots.py](customized_subplots.py)]
   ![customized_subplots.png](customized_subplots.png)


Useful Links:
------

1. Plotly Python Library
https://plot.ly/python/

2. Make a Heatmap
http://help.plot.ly/make-a-heatmap/

## Short note for functional annotation against the COG, KEGG and CAZy databases using BioSAK (on Katana)


### Install BioSAK with Python's virtual environment 

BioSAK is a place where I put together some of my frequently used python scripts. 
You can install it on Katana with Python's virtual environment. 

1. Log into katana

       ssh z1234567@katana.restech.unsw.edu.au -o "ServerAliveInterval 10"
        
1. Start an interactive job (running programs on Katana head node is not allowed)    
        
       qsub -I -l nodes=1:ppn=6,mem=60gb,walltime=05:59:00

1. Create a Python3 virtual environment and install BioSAK

       module load python/3.7.3
       mkdir ~/mypython3env_BioSAK
       python3 -m venv --system-site-packages ~/mypython3env_BioSAK
       source ~/mypython3env_BioSAK/bin/activate
       pip3 install BioSAK
  
       # for future updating
       pip3 install --upgrade BioSAK
       
             
1. BioSAK is ready for running now. If you want to run BioSAK in the future, just run the following commands to activate python's virtual environment.

       module load python/3.7.3
       source ~/mypython3env_BioSAK/bin/activate
       BioSAK -h


### Prepare database files

1. COG (version 2020)

       # create a folder and download db files to this folder
       cd db_COG2020
       wget https://ftp.ncbi.nih.gov/pub/COG/COG2020/data/cog-20.fa.gz
       wget https://ftp.ncbi.nih.gov/pub/COG/COG2020/data/cog-20.cog.csv
       wget https://ftp.ncbi.nih.gov/pub/COG/COG2020/data/cog-20.def.tab
       wget https://ftp.ncbi.nih.gov/pub/COG/COG2020/data/fun-20.tab
       wget https://ftp.ncbi.nih.gov/pub/COG/COG2020/data/Readme.2020-11-25.txt
       gunzip cog-20.fa.gz
        
       # make blast db
       module load blast+/2.11.0
       makeblastdb -in cog-20.fa -dbtype prot -parse_seqids -logfile cog-20.fa.log
        
       # make diamond db
       module load diamond/0.9.31
       diamond makedb --in cog-20.fa --db cog-20.fa.dmnd --quiet

1. dbCAN (version 9, released August 2020)

       cd db_dbCAN_V9
       wget http://bcb.unl.edu/dbCAN2/download/Databases/V9/hmmscan-parser.sh
       wget http://bcb.unl.edu/dbCAN2/download/Databases/V9/CAZyDB.07302020.fam-activities.txt
       wget http://bcb.unl.edu/dbCAN2/download/Databases/V9/dbCAN-HMMdb-V9.txt
       mv CAZyDB.07302020.fam-activities.txt CAZyDB.fam-activities.txt
       mv dbCAN-HMMdb-V9.txt dbCAN-fam-HMMs.txt
       module load hmmer/3.3
       hmmpress dbCAN-fam-HMMs.txt
       
1. KEGG

   + Please note that the KEGG database files (e.g. [genus_prokaryotes.pep.gz](https://www.kegg.jp/kegg/download/Readme/README.fasta)) are not for free, if you don't have permission to use these files, 
      you can use [BlastKOALA](https://www.kegg.jp/blastkoala/) or [GhostKOALA](https://www.kegg.jp/ghostkoala/) for KEGG annotation, which are free web-based online tools developed by the KEGG team.
      BlastKOALA and GhostKOALA assign K numbers to the user's sequence data by BLAST and GHOSTX searches, respectively, against a nonredundant set of KEGG GENES.
     
   + BlastKOALA: https://www.kegg.jp/blastkoala/ 
     (Up to **ten thousand** sequences may be uploaded)
   
   + GhostKOALA: https://www.kegg.jp/ghostkoala/ 
     (The file size of up to **300 MB** (one million sequences with average length of 300 or three million sequences with average length of 100) may be uploaded)
   
   + BlastKOALA Step-by-step Instructions: https://www.kegg.jp/blastkoala/help_blastkoala.html


### Functional annotation

1. COG

       module load python/3.7.3
       source ~/mypython3env/bin/activate
       module load diamond/0.9.31
       cd /srv/scratch/z5039045/Kelp_coassembly
       BioSAK COG2020 -i faa_files -x faa -db_dir path/to/db_COG2020 -m P -t 6 -diamond

1. CAZy (using dbCAN)

       module load python/3.7.3
       source ~/mypython3env/bin/activate
       module load hmmer/3.3
       cd /srv/scratch/z5039045/Kelp_coassembly
       BioSAK dbCAN -i faa_files -x faa -db_dir path/to/db_dbCAN_V9 -m P -t 6

1. KEGG

   If you have done KEGG annotation with BlastKOALA, you can still use BioSAK to summarize your annotation results (e.g. the number/percentage of query genes annotated to each KO at different levels).  
  
       module load python/3.7.3
       source ~/mypython3env/bin/activate
       module load diamond/0.9.24
       cd /srv/scratch/z5039045/Kelp_coassembly
       BioSAK KEGG -seq_in faa_files -x faa -db_dir /srv/scratch/z5039045/DB/KEGG_2016-09-26 -t 6 -diamond
       BioSAK KEGG -ko_in BlastKOALA_output_files -x txt -db_dir /srv/scratch/z5039045/DB/KEGG_2016-09-26 -t 6


### Output files (take COG as an example)

1. Annotation result for each query gene.

    | Query | ID | Category | Description |
    |:---:|:---:|:---:|---|
    | gene_1 | COG0801 | H | 7,8-dihydro-6-hydroxymethylpterin pyrophosphokinase |
    | gene_2 ||||
    | gene_3 | COG0514 | L | Superfamily II DNA helicase RecQ |
    | gene_4 | COG1309 | K | DNA-binding protein, AcrR family, includes nucleoid occlusion protein SlmA |
    | gene_5 | COG0514 | L | Superfamily II DNA helicase RecQ |

1. The number/percentage of genes annotated to each COG ID/category.

    | ID | GeneNumber | Description |
    |:---:|:---:|---|
    | COG0514 | 2 | Superfamily II DNA helicase RecQ |
    | COG0801 | 1 | 7,8-dihydro-6-hydroxymethylpterin pyrophosphokinase |
    | COG1309 | 1 | DNA-binding protein, AcrR family, includes nucleoid occlusion protein SlmA |

    | Category | GeneNumber | Description |
    |:---:|:---:|---|
    | L | 2 | Replication, recombination and repair |
    | H | 1 | Coenzyme transport and metabolism |
    | K | 1 | Transcription |

1. A data matrix of the number/percentage of genes annotated to each COG ID/category for each of your query file, if you annotated multiple sequence files together.

    | | COG0514 | COG0801 | COG1309 | ... |
    |:---:|:---:|:---:|:---:|:---:|
    | file_1 | 8 | 0 | 1 | ... |
    | file_2 | 3 | 0 | 2 | ... |
    | file_3 | 5 | 1 | 4 | ... |
    | file_4 | 3 | 9 | 1 | ... |
    | file_5 | 4 | 0 | 3 | ... |
    |  ...   |   |   |   |     |

       
### References and online resources:

+ dbCAN2: http://bcb.unl.edu/dbCAN2/blast.php

# About

##Examples to plot in python.

####2D_line
   ![2D_line](2D_line.png)

####2D_scatter_1
   ![2D_scatter_1](2D_scatter_1.png)

####2D_scatter_2_dot_size
   ![2D_scatter_2_dot_size](2D_scatter_2_dot_size.png)

####2D_scatter_3_groups
   ![2D_scatter_3_groups](2D_scatter_3_groups.png)

####Density_plot_gaussian_kde
   ![Density_plot_gaussian_kde](Density_plot_gaussian_kde.png)

####Distribution_plot_4_in_1
   ![Distribution_plot_4_in_1](Distribution_plot_4_in_1.png)

####Heatmap_in_ploty
   ![Heatmap_in_ploty](Heatmap_in_ploty.png)

####Add_text_in_matplotlib
   ![Add_text_in_matplotlib](Add_text_in_matplotlib.png)

####3D_scatter
   ![3D_scatter](3D_scatter.png)


#####Useful Links:

1. Plotly Python Library
https://plot.ly/python/

2. Make a Heatmap
http://help.plot.ly/make-a-heatmap/

library(googleVis)

plot_99_200_length = read.csv('/Users/songweizhi/Desktop/googleVis_example_data.csv', header = TRUE)
Sankey_plot_99_200_length <- gvisSankey(plot_99_200_length,
                                        options = list(sankey = "{node:{colorMode:'unique', labelPadding: 10 },link:{colorMode:'source'}}", 
                                                       height = 1200, 
                                                       width = 600))
plot(Sankey_plot_99_200_length)

library(dplyr)


#################### How To Create A Simple Data Frame in R? ####################

# make some vectors first
Died.At <- c(22,40,72,41)
Writer.At <- c(16, 18, 36, 36)
First.Name <- c("John", "Edgar", "Walt", "Jane")
Second.Name <- c("Doe", "Poe", "Whitman", "Austen")
Sex <- c("MALE", "MALE", "MALE", "FEMALE")
Date.Of.Death <- c("2015-05-10", "1849-10-07", "1892-03-26","1817-07-18")

# combine the vectors with the data.frame()
writers_df <- data.frame(Died.At, Writer.At, First.Name, Second.Name, Sex, Date.Of.Death)

# Use str() to get more info about the generated data frame
str(writers_df)
writers_df


################################### add row name ###################################

setwd('/Users/songweizhi/R_scripts')
csv_in ='Demo_03_ESBL.csv'

# read in csv
AR_matrix = read.csv(csv_in)
AR_matrix

row.names(AR_matrix) = paste('Sample', seq.int(nrow(AR_matrix)), sep = "_")
AR_matrix


############################ subset df to get metadata ############################

AR_matrix_metadata = AR_matrix[,1:4]
AR_matrix_metadata


########################## subset df to get value matrix ##########################

AR_matrix_value = AR_matrix[,5:ncol(AR_matrix)]
AR_matrix_value


###################################################################################

rm(list=ls())

file_list = dir(path = '/Users/songweizhi/Desktop/ccc', pattern = '.fasta')

print(file_list)


library(tools)

pwd_file = '/Users/songweizhi/Desktop/grouping_out.purity.txt'

file_path = dirname(pwd_file)
file_path
# "/Users/songweizhi/Desktop"

file_path2 = dirname('grouping_out.purity.txt')
file_path2
# "."

file_name = basename(pwd_file)
file_name
# "grouping_out.purity.txt"

file_name_without_extension = file_path_sans_ext(file_name)
file_name_without_extension
# "grouping_out.purity"

file_name_without_extension2 = file_path_sans_ext(basename(pwd_file))
file_name_without_extension2
# "grouping_out.purity"

file_extension = file_ext(file_name)
file_extension
# "txt"

file_extension2 = file_ext(pwd_file)
file_extension2
# "txt"

# remove path from bin_subfolder
bin_subfolder_only_name = strsplit(bin_subfolder, '/')[[1]][-1]

library(ape)
library(GMD)
library(tools)
library(optparse)

# usgae
# Rscript ~/R_scripts/newick_tree/Tree2grouping.R -t human_gut_tree.newick

MOAR_LETTERS <- function(n=2) {
  n <- as.integer(n[1L])
  if(!is.finite(n) || n < 2)
    stop("'n' must be a length-1 integer >= 2")
  res <- vector("list", n)
  res[[1]] <- LETTERS
  for(i in 2:n)
    res[[i]] <- c(sapply(res[[i-1L]], function(y) paste0(y, LETTERS)))
  unlist(res)
}
group_id_letters = MOAR_LETTERS(3)

option_list = list(
  
  make_option(c("-t", "--tree"), 
              type="character", 
              default=NULL, 
              help="input file name", 
              metavar="character"));
  
opt_parser = OptionParser(option_list=option_list);
opt = parse_args(opt_parser);
wd = getwd()

tree_file_in = opt$tree
tree_file_in_name_no_extension = file_path_sans_ext(basename(tree_file_in))
grouping_file_out = paste(tree_file_in_name_no_extension, 'grouping.txt', sep = '_')
tree_txt_file_with_group = paste(tree_file_in_name_no_extension, 'with_group.txt', sep = '_')
tree_txt_file_only_group = paste(tree_file_in_name_no_extension, 'only_group.txt', sep = '_')
tree_plot_file = paste(tree_file_in_name_no_extension, '.jpg', sep = '_')
tree_plot_file_with_group = paste(tree_file_in_name_no_extension, 'with_group.jpg', sep = '_')
tree_plot_file_only_group = paste(tree_file_in_name_no_extension, 'only_group.jpg', sep = '_')

pwd_grouping_file_out = paste(wd, grouping_file_out, sep = '/')
pwd_tree_txt_file_with_group = paste(wd, tree_txt_file_with_group, sep = '/')
pwd_tree_txt_file_only_group = paste(wd, tree_txt_file_only_group, sep = '/')

pwd_tree_plot_file = paste(wd, tree_plot_file, sep = '/')
pwd_tree_plot_file_with_group = paste(wd, tree_plot_file_with_group, sep = '/')
pwd_tree_plot_file_only_group = paste(wd, tree_plot_file_only_group, sep = '/')

# read in tree file
SCG_tree = read.tree(tree_file_in)

# get distance matrix from input tree
distance_matrix = cophenetic(SCG_tree)

# sort the matrix
distance_matrix = distance_matrix[order(row.names(distance_matrix)),order(row.names(distance_matrix))]

# get the optimal k value
dist.obj <- dist(distance_matrix)
hclust.obj <- hclust(dist.obj)
css.obj <- css.hclust(dist.obj,hclust.obj)
elbow.obj <- elbow.batch(css.obj, ev.thres = 0.9)
#elbow.obj <- elbow.batch(css.obj)
k <- elbow.obj$k; cutree.obj <- cutree(hclust.obj,k=k)

# perform kmeans analysis of the matrix and get predicted clusters
clusters = kmeans(distance_matrix, k, nstart = 1000)$cluster

# turn predicted clusters to dataframe and write out 
clusters_df = data.frame(clusters)

# trun row name (bin id) to name column
clusters_df_row_name_in_column <- data.frame(names = row.names(clusters_df), clusters_df, row.names = NULL)

# sort dataframe according to group index
clusters_df_sorted = clusters_df_row_name_in_column[order(clusters_df_row_name_in_column$clusters),]

# add group information 
clusters_df_sorted$group = with(clusters_df_sorted, group_id_letters[clusters])

# extract need information for output
clusters_df_for_write = data.frame(clusters_df_sorted$group, clusters_df_sorted$names)

# write out into grouping .txt 
write.table(clusters_df_for_write, file = pwd_grouping_file_out, row.names=FALSE, col.names = FALSE, sep = ',', quote = FALSE)

# plot input tree
SCG_tree = read.tree(tree_file_in)
jpeg(pwd_tree_plot_file, width = 1600, height = 1600, units = "px", quality = 100, pointsize = 30)
plot.phylo(SCG_tree, 'u', font = 1, cex = 0.5, label.offset = 0, lab4ut = 'axial')
dev.off()


# plot SCG tree with group
SCG_tree_with_group = read.tree(tree_file_in)
i = 1
for (i in 1:length(SCG_tree_with_group$tip.label)) {
  label_name = SCG_tree_with_group$tip.label[i]
  label_name_row_num = which(clusters_df_for_write$clusters_df_sorted.names == label_name)
  group_id = clusters_df_for_write$clusters_df_sorted.group[label_name_row_num]
  SCG_tree_with_group$tip.label[i] = paste(group_id, SCG_tree_with_group$tip.label[i], sep = '_')
  i = i + 1}
# plot tree with group
jpeg(pwd_tree_plot_file_with_group, width = 1600, height = 1600, units = "px", quality = 100, pointsize = 30)
plot.phylo(SCG_tree_with_group, 'u', font = 1, cex = 0.5, label.offset = 0, lab4ut = 'axial')
dev.off()
write.tree(SCG_tree_with_group, file=pwd_tree_txt_file_with_group)

# plot SCG tree only group
SCG_tree_only_group = read.tree(tree_file_in)
i = 1
for (i in 1:length(SCG_tree_only_group$tip.label)) {
  label_name = SCG_tree_only_group$tip.label[i]
  label_name_row_num = which(clusters_df_for_write$clusters_df_sorted.names == label_name)
  group_id = clusters_df_for_write$clusters_df_sorted.group[label_name_row_num]
  SCG_tree_only_group$tip.label[i] = paste(group_id)
  i = i + 1}
# plot tree only group
jpeg(pwd_tree_plot_file_only_group, width = 1600, height = 1600, units = "px", quality = 100, pointsize = 30)
plot.phylo(SCG_tree_only_group, 'u', font = 1, cex = 0.7, label.offset = 0, lab4ut = 'axial')
#plot.phylo(SCG_tree_only_group, font = 1, cex = 0.7, label.offset = 0.1, lab4ut = 'axial')

dev.off()
write.tree(SCG_tree_only_group, file=pwd_tree_txt_file_only_group)

library(circlize)
mat = matrix(1:9, 3)
mat

rownames(mat) = letters[1:3]
colnames(mat) = LETTERS[1:3]
df = data.frame(from = letters[1:3], to = LETTERS[1:3], value = 1:3)
df

chordDiagram(mat)
circos.clear()

chordDiagram(df) 
circos.clear()

# SRAdb
source (" http://bioconductor.org/biocLite.R")
biocLite("SRAdb")
library(SRAdb)

sqlfile = getSRAdbFile()
sra_con = dbConnect(SQLite(), sqlfile)


#rs <- getSRA (search_terms ='"antarctic", "metagenome"', out_types=c('run','study'), sra_con=sra_con, acc_only=0)
rs <- getSRA (search_terms ='"soil", "metagenome"', out_types=c('run','study'), sra_con=sra_con, acc_only=0)

write.csv(rs, "soil_metagenome_output.txt")


## Download sra files from NCBI SRA using ftp protocol:
getSRAfile( in_acc = c("SRR000648","SRR000657"), sra_con = sra_con, destDir = getwd(), fileType = 'sra' )



?getSRA

#!/usr/bin/env Rscript

# Copyright (C) 2017, Weizhi Song, Torsten Thomas.
# songwz03@gmail.com or t.thomas@unsw.edu.au

# Binning_refiner is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Binning_refiner is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.

# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


suppressMessages(suppressWarnings(library(tools)))
suppressMessages(suppressWarnings(library(optparse)))
suppressMessages(suppressWarnings(library(googleVis)))


option_list = list(
  
  make_option(c("-f", "--file"), 
              type="character", 
              default=NULL, 
              help="input file name", 
              metavar="character"),
  
  make_option(c("-x", "--width"), 
              type="double", 
              default=600, 
              help="the width of plot [default= %default]", 
              metavar="double"),
  
  make_option(c("-y", "--height"), 
              type="double", 
              default=1000, 
              help="the height of plot [default= %default]", 
              metavar="double")); 

opt_parser = OptionParser(option_list=option_list);
opt = parse_args(opt_parser);


if (is.null(opt$file)){
  print_help(opt_parser)
  stop("At least one argument must be supplied (input file).n", call.=FALSE)}


my_data = read.csv(opt$file, header = TRUE)
Sankey_plot_my_data <- gvisSankey(my_data, options = list(sankey = "{node:{colorMode:'unique', labelPadding: 20, nodePadding: 8},link:{colorMode:'source'}}",
                                                       height = opt$height, 
                                                       width = opt$width))

output_file = paste(file_path_sans_ext(opt$file), "html", sep=".")
sink(file = output_file, append = FALSE, type = c("output", "message"), split = FALSE)
print(Sankey_plot_my_data)
sink()

report_message = paste('Done! Sankey plot exported to: ', output_file, sep = '')
message(report_message)

install.packages("ggplot2")
library(ggplot2)

d
l_l = d
jpeg(filename = '/Users/weizhisong/Desktop/L_L.jpg')
hist(d, axes = T, xlab = 'Identity', xlim = range(60:85),ylab = 'Target Frequency', probability = T, main = 'Group: L_L', border = 'blue')
dev.off()
lines(density(l_l,width = 5), lwd = 2)
dev.off()

e = c(1,2,3,4,5,4,3,2,3,3,4,3,4,3,4,5,6)
hist(e)
dev.off()
lines(density(e,width = 5), lwd = 2)
dev.off()

check.packages <- function(pkg){
    new.pkg <- pkg[!(pkg %in% installed.packages()[, "Package"])]
    if (length(new.pkg))
        install.packages(new.pkg, dependencies = TRUE)
    sapply(pkg, require, character.only = 1)
}


# install packages if not
packages<-c("optparse", "ggplot2")
invisible(suppressMessages(check.packages(packages)))


##################################### Usage example #####################################

# Rscript ~/Rscripts/COG_summary_boxplot.R -i COG_summary_47bins_in_percent.csv -o HGT_COG.png
# COG annotation results for the HGTs must be in the last two rows

#########################################################################################


get_shape_list_blast = function(csv_file){
  # read in dataframe from csv file
  my_data = read.csv(csv_file, row.names = 1)
  
  # get the number of rows and columns
  row_num = dim(my_data)[1]
  col_num = dim(my_data)[2]
  
  # slice dataframe
  input_genomes_COG = my_data[1:(row_num-2),]
  HGT_COG = my_data[row_num-1,]
  
  # get color list
  shape_list  = c()
  for(each_col in names(my_data)){
    #each_col_mean = mean(my_data[each_col][1:(row_num-2),])
    each_col_quatile = quantile(my_data[each_col][1:(row_num-2),])
    each_col_quatile_low = each_col_quatile[[2]]
    each_col_quatile_high = each_col_quatile[[4]]
      
    each_col_HGT = my_data[each_col][row_num-1,]
    #compare = each_col_HGT - each_col_mean
    current_shape = ''
    if ((each_col_HGT - each_col_quatile_high) > 0){
      current_shape = 24
    } else if ((each_col_HGT - each_col_quatile_low) < 0){
      current_shape = 25
    } else {
      current_shape = 22
    }
    shape_list = c(shape_list, current_shape)
  }
  return(shape_list)
}


get_shape_list_tree = function(csv_file){
  # read in dataframe from csv file
  my_data = read.csv(csv_file, row.names = 1)
  
  # get the number of rows and columns
  row_num = dim(my_data)[1]
  col_num = dim(my_data)[2]
  
  # slice dataframe
  input_genomes_COG = my_data[1:(row_num-2),]
  HGT_COG = my_data[row_num,]
  
  # get color list
  shape_list  = c()
  for(each_col in names(my_data)){
    each_col_mean = mean(my_data[each_col][1:(row_num-2),])
    each_col_quatile = quantile(my_data[each_col][1:(row_num-2),])
    each_col_quatile_low = each_col_quatile[[2]]
    each_col_quatile_high = each_col_quatile[[4]]
    
    each_col_HGT = my_data[each_col][row_num,]
    #compare = each_col_HGT - each_col_mean
    current_shape = ''
    if ((each_col_HGT - each_col_quatile_high) > 0){
      current_shape = 24
    } else if ((each_col_HGT - each_col_quatile_low) < 0){
      current_shape = 25
    } else {
      current_shape = 22
    }
    shape_list = c(shape_list, current_shape)
  }
  return(shape_list)
}


get_color_list_blast = function(csv_file){
  # read in dataframe from csv file
  my_data = read.csv(csv_file, row.names = 1)
  
  # get the number of rows and columns
  row_num = dim(my_data)[1]
  col_num = dim(my_data)[2]
  
  # slice dataframe
  input_genomes_COG = my_data[1:(row_num-2),]
  HGT_COG = my_data[row_num-1,]
  
  # get color list
  shape_list  = c()
  for(each_col in names(my_data)){
    #each_col_mean = mean(my_data[each_col][1:(row_num-2),])
    each_col_quatile = quantile(my_data[each_col][1:(row_num-2),])
    each_col_quatile_low = each_col_quatile[[2]]
    each_col_quatile_high = each_col_quatile[[4]]
    
    each_col_HGT = my_data[each_col][row_num-1,]
    #compare = each_col_HGT - each_col_mean
    current_shape = ''
    if ((each_col_HGT - each_col_quatile_high) > 0){
      current_shape = 'black'
    } else if ((each_col_HGT - each_col_quatile_low) < 0){
      current_shape = 'black'
    } else {
      current_shape = 'black'
    }
    shape_list = c(shape_list, current_shape)
  }
  return(shape_list)
}


get_color_list_tree = function(csv_file){
  # read in dataframe from csv file
  my_data = read.csv(csv_file, row.names = 1)
  
  # get the number of rows and columns
  row_num = dim(my_data)[1]
  col_num = dim(my_data)[2]
  
  # slice dataframe
  input_genomes_COG = my_data[1:(row_num-2),]
  HGT_COG = my_data[row_num,]
  
  # get color list
  shape_list  = c()
  for(each_col in names(my_data)){
    each_col_mean = mean(my_data[each_col][1:(row_num-2),])
    each_col_quatile = quantile(my_data[each_col][1:(row_num-2),])
    each_col_quatile_low = each_col_quatile[[2]]
    each_col_quatile_high = each_col_quatile[[4]]
    
    each_col_HGT = my_data[each_col][row_num,]
    #compare = each_col_HGT - each_col_mean
    current_shape = ''
    if ((each_col_HGT - each_col_quatile_high) > 0){
      current_shape = 'black'
    } else if ((each_col_HGT - each_col_quatile_low) < 0){
      current_shape = 'black'
    } else {
      current_shape = 'black'
    }
    shape_list = c(shape_list, current_shape)
  }
  return(shape_list)
}


option_list = list(
  
  make_option(c("-i", "--input"), 
              type="character", 
              help="input file name", 
              metavar="character"),
  
  make_option(c("-o", "--out"), 
              type="character", 
              help="output plot name", 
              metavar="character")); 

opt_parser = OptionParser(option_list=option_list);
opt = parse_args(opt_parser);

csv_file = opt$input
my_data = read.csv(csv_file, row.names = 1)
row_num = dim(my_data)[1]
shape_list_tree = get_shape_list_tree(csv_file)
shape_list_blast = get_shape_list_blast(csv_file)
color_list_tree = get_color_list_tree(csv_file)
color_list_blast = get_color_list_blast(csv_file)

# plot
ggplot() + 
  geom_boxplot(data = stack(my_data[1:(row_num-2),]), aes(x = ind, y = values)) + 
  
  geom_point(data = data.frame(x = factor(colnames(my_data)), 
                               y = as.numeric(my_data[row_num-1,])),
             aes(x=x, y=y),
             color = color_list_blast, 
             shape = shape_list_blast,
             fill = color_list_blast, 
             stroke = 0.8,
             size = 2.5) + 
  
  geom_point(data = data.frame(x = factor(colnames(my_data)), 
                               y = as.numeric(my_data[row_num,])),
             aes(x=x, y=y),
             color = color_list_tree, 
             shape = shape_list_tree,
             stroke = 0.8,
             size = 2.5) + 

  theme_bw() + # white background
  theme(panel.border = element_blank(), 
        panel.grid.major = element_blank(),
        panel.grid.minor = element_blank(), 
        axis.line = element_line(colour = "black"),
        axis.text.x = element_text(colour="black",size=12,angle=0,hjust=.5,vjust=.5,face="plain"),
        axis.text.y = element_text(colour="black",size=12,angle=0,hjust=.5,vjust=.5,face="plain"),
        axis.title.x = element_text(colour="black",size=12,angle=0,hjust=.5,vjust=0,face="plain"),
        axis.title.y = element_text(colour="black",size=12,angle=90,hjust=.5,vjust=0,face="plain"))+
  labs(x = "COG category", y = 'Proportion') # label of x and y axis

ggsave(opt$out, width = 10, height = 5)

################################# stat_Logistic_Regression #################################

# https://stats.idre.ucla.edu/r/dae/logit-regression/

# https://www.datacamp.com/community/tutorials/logistic-regression-R

# https://www.r-bloggers.com/how-to-perform-a-logistic-regression-in-r/

# Question: How To Do Clustering Based On Cutoff Distance Value In R
# https://www.biostars.org/p/52207/


# Create a sample data set.
y <- matrix(rnorm(50), 10, 5, dimnames=list(paste("g", 1:10, sep=""), paste("t", 1:5, sep="")))

# hierarchical cluster using Euclidean distance to get a range of distances
# for which the integer 2 is relevant
hr <- hclust(dist(y), method = "complete", members=NULL)

# examine the dendrogram
plot(hr)

# cut at a distance of 2, and get cluster memberships
myhcl <- cutree(hr, h=2)

# highlight our clusters on the dendrogram
rect.hclust(hr, h=2)

library(ape)
library(tools)
library(optparse)

tree_file_in = '/Users/songweizhi/Desktop/bac120_r83.tree.txt'
tree_plot_out = '/Users/songweizhi/Desktop/bac120_r83.tree.jpg'

  
# plot SCG tree only group
SCG_tree = read.tree(tree_file_in)

# plot tree only group
jpeg(tree_plot_out, width = 1600, height = 1600, units = "px", quality = 100, pointsize = 30)
plot.phylo(SCG_tree, 'u', font = 1, cex = 0.7, label.offset = 0.1, lab4ut = 'axial')
dev.off()

################################# One_Sample_Wilcoxon_test #################################

# The one-sample Wilcoxon signed rank test is a non-parametric alternative to one-sample t-test when the data cannot be 
# assumed to be normally distributed. It’s used to determine whether the median of the sample is equal to a known standard 
# value (i.e. theoretical value).

# Note that, the data should be distributed symmetrically around the median. In other words, there should be roughly the 
# same number of values above and below the median.


# Here, we’ll use an example data set containing the weight of 10 mice. 
# We want to know, if the median weight of the mice differs from 25g?
set.seed(1234)
my_data <- data.frame(name = paste0(rep("M_", 10), 1:10), weight = round(rnorm(10, 20, 2), 1))
my_data


# test 
shapiro.test(my_data$weight)


# to be added

# turn what to write out into dataframe
for_write_df = data.frame(each_seq_id, bin_subfolder_only_name, each_bin)

# write out into file
write.table(for_write_df, file_out_handle, row.names = FALSE, col.names = FALSE, quote = FALSE, sep = ",")

dist.au <- read.csv("http://rosetta.reltech.org/TC/v15/Mapping/data/dist-Aus.csv", row.names = 1)

fit <- cmdscale(dist.au, eig = TRUE, k = 2)
x <- fit$points[, 1]
y <- fit$points[, 2]

plot(x, y, pch = 19, xlim = range(x) + c(0, 600))
city.names <- c("Adelaide", "Alice Springs", "Brisbane", "Darwin", "Hobart", "Melbourne", "Perth", "Sydney")
text(x, y, pos = 4, labels = city.names)

?cmdscale

faithful
duration = faithful$eruptions
duration
quantile(duration, c(.05, .32, .57, .98)) 

plot(density(duration))
barplot(duration)

help(quantile)
write.csv(duration, file = '/Users/weizhisong/Desktop/duration.csv')

# ANOVA in R

y1 = c(18.2, 20.1, 17.6, 16.8, 18.8, 19.7, 19.1)
y2 = c(17.4, 18.7, 19.1, 16.4, 15.9, 18.4, 17.7)
y3 = c(15.2, 18.8, 17.7, 16.5, 15.9, 17.1, 16.7)

# combine all number list together
y = c(y1, y2, y3)

# generate label
n = rep(7, 3)
group = rep(1:3, n)

# Apply A Function Over An Array
tmp = tapply(y, group, stem)
stem(y)

tmpfn = function(x) c(sum = sum(x), mean = mean(x), var = var(x), n = length(x))
tapply(y, group, tmpfn)

data = data.frame(y = y, group = factor(group))
data

# fit linear model
fit = lm(y ~ group, data)
fit
abline(fit)

plot(y ~ group, data)

# ANOVA
anova(fit)

?anova

# check.packages function: install and load multiple R packages.
# Check to see if packages are installed. Install them if they are not, then load them into the R session.
check_packages <- function(pkg){
  new.pkg <- pkg[!(pkg %in% installed.packages()[, "Package"])]
  if (length(new.pkg))
    install.packages(new.pkg, dependencies = TRUE)
  sapply(pkg, require, character.only = 1)
}


# install packages if not 
packages<-c("optparse", "circlize")
invisible(suppressMessages(check_packages(packages)))

# http://manuals.bioinformatics.ucr.edu/home/R_BioCondManual?tmpl=%2Fsystem%2Fapp%2Ftemplates%2Fprint%2F&showPrintDialog=1
# 
# #############################################################################################
# ## All Possible Intersects: for comprehensive overlap analyses of 2-20 or more sample sets ##
# #############################################################################################
# source("http://faculty.ucr.edu/~tgirke/Documents/R_BioCond/My_R_Scripts/overLapper.R") 
# # To compute all possible intersects among more than two samples at the same time - such as common in AB, ABC, 
# # ABCD and so on - the overLapper function can be used. Note: processing more than 20 sets with this function can take 
# # a long time, because the complexity of all possible intersects increases with the number of sample sets n according 
# # to this relationship: (2^n) - 1 (includes self comparisons). This means there are 63 possible intersects for n=6, 1,023 
# # for n=10, 32,767 for n=15 and 33,554,431 for n=25. With the current implementation, the computation time is about 0.1 
# # second for n=10 and 2.5 seconds for n=15.
# setlist <- lapply(1:6, function(x) sample(letters, 20)); names(setlist) <- LETTERS[seq(along=setlist)] 
# # To work with the overLapper function, the sample sets need to be stored in a list object where the different 
# # components are named by unique identifiers: A, B, C, ..., Z.
# OLlist <- overLapper(setlist=setlist, complexity=1:length(setlist), sep="-", type="intersects"); OLlist; names(OLlist) 
# # Computes all possible intersects for the samples stored in 'setlist'. The results are returned as a list where each 
# # overlap component is labeled by the corresponding sample names. For instance, the name 'A-B-C' indicates that the 
# # entries are common in samples A, B and C. The seperator used for naming the intersect samples can be specified under 
# # the 'sep' argument. The complexity level range to consider can be controlled with the 'complexity' argument, which 
# # can have values from 2 to the total number of samples.
# OLlist[[2]]; OLlist[[3]] # Returns the corresponding intersect matrix and complexity levels.
# OLexport <- as.matrix(unlist(sapply(OLlist[[4]], paste, collapse=" ")))
# write.table(OLexport, file="test.xls", col.names=F, quote=F, sep="\t") # Exports intersect data in tabular format to a file.
# counts <- sapply(OLlist[[4]], length) # Counts the number of elements in each intersect component.
# tapply(counts, OLlist[[3]], function(x) rev(sort(x))) 
# # Sorts the overlap results within each complexity level by their size. This allows to identify the sample set 
# # combinations with the largest intersect within each complexity level.
# x11(height=12, width=8); olBarplot(OLlist=OLlist, horiz=T, las=1, cex.names=0.6, main="Intersect Bar Plot") 
# # Plots the counts as bar diagram. More details on this function are provided in the Venn diagram section. 
 




#####################################################################################################
## All Pairwise Intersects: to identify and cluster overlaps among two to thousands of sample sets ##
#####################################################################################################
setlist <- lapply(11:30, function(x) sample(letters, x, replace=TRUE)); names(setlist) <- paste("S", seq(along=setlist), sep="")
# To work with the following function, the sample sets (here 20) need to be stored in a list object (here 'setlist')
# where each component is named by a unique identifier (here S1-S20).
setlist <- sapply(setlist, unique)
olMA <- sapply(names(setlist), function(x) sapply(names(setlist), function(y) sum(setlist[[x]] %in% setlist[[y]]))); olMA
# Creates an intersect matrix for all pairwise sample comparisons stored in 'setlist'. This approach scales well up to
# 3several thousands of sample sets.
library("gplots")
#heatmap.2(olMA, trace="none", Colv="none", Rowv="none", dendrogram="none", col=colorpanel(40, "darkred", "orange", "yellow")) # Plots intersect matrix as heatmap.
heatmap.2(olMA, trace="none", col=colorpanel(40, "darkred", "orange", "yellow"))
# Hierarchical clustering of the rows and columns of the intersect matrix 'olMA'. The result is plotted as heatmap
# with two identical dendrograms representing the outcome of the hierarchical clustering. The latter is internally
# performed by calls of heatmap.2() to the functions dist() and hclust() using their default settings: euclidean
# distances and complete linkage. Note: the distance matrix used for clustering in this examples is based on the
# row-to-row (column-to-column) similarities in the olMA object. The next example shows how one can use the olMA
# object directly as distance matrix for clustering after transforming the intersect counts into similarity measures,
# such as Jaccard or Rand indices.
# diffMA1 <- sapply(names(setlist), function(x) sapply(names(setlist), function(y) sum(!setlist[[x]] %in% setlist[[y]])))
# diffMA2 <- sapply(names(setlist), function(x) sapply(names(setlist), function(y) sum(!setlist[[y]] %in% setlist[[x]])))
# jaccardMA <- olMA/(diffMA1+diffMA2+olMA)
# hr <- hclust(as.dist(1-jaccardMA), method = "complete", members=NULL)
# heatmap.2(jaccardMA, Rowv=as.dendrogram(hr), Colv=as.dendrogram(hr), trace="none", col=colorpanel(40, "darkred", "orange", "yellow"))
# # Uses the olMA for clustering after transfroming its intersect counts into Jaccard (Tanimoto) similarity indices.
# # This transformation can give reasonable results for sample sets with large size differences. Many alternative
# # similarity measures for set comparisons could be considered here.
# setlist[["S1"]][setlist[["S1"]] %in% setlist[["S2"]]]
# # Example for returning the intersect entries for one pairwise comparison, here S1 and S2.
# name1 <- matrix(colnames(olMA), length(olMA[,1]), length(olMA[,1]), byrow=T)
# name2 <- matrix(colnames(olMA), length(olMA[,1]), length(olMA[,1]), byrow=F)
# mynames <- paste(name1, name2, sep="_"); mynames <- lapply(strsplit(mynames, "_"), sort)
# mynames <- sapply(mynames, paste, collapse="_"); olV <- as.vector(olMA)
# names(olV) <- mynames; olV <- olV[!duplicated(names(olV))]; sort(olV)
# # Converts the intersect matrix 'olMA' into a named vector sorted by intersect size. This allows to identify the
# # combinations of pairwise sample comparisons that have the largest or smallest intersects.
# 



#' ######################################################################################################
#' ## Presence-absence matrices: to indentify memberships of items across large numbers of sample sets ##
#' ######################################################################################################
#' setlist <- lapply(11:30, function(x) sample(letters, x, replace=TRUE)); names(setlist) <- paste("S", seq(along=setlist), sep="") 
#' # Generates a sample data set.
#' source("http://faculty.ucr.edu/~tgirke/Documents/R_BioCond/My_R_Scripts/overLapper.R") 
#' # Imports the required overLapper() function.
#' paMA <- overLapper(setlist=setlist, type="intersects", complexity=2)[[2]]
#' paMA[names(rev(sort(rowSums(paMA)))),] 
#' # Creates a presence-absence matrix of all items across their sample sets. In this matrix the presence information is 
#' # indicated by ones and its rows are sorted by the presence frequencies. Alternative versions of the present-absent 
#' @ matrix can be returned by setting the 'type' argument to 1, 2 or 3.
#' library("gplots"); heatmap.2(paMA, trace="none", Colv="none", Rowv="none", dendrogram="none", col=c("white", "gray")) 
#' # Plots the present-absent matrix as heatmap.
#' rowSums(paMA) # Returns the presence frequencies of the items in the sample sets.
#' sapply(rownames(paMA), function(x) colnames(paMA)[paMA[x, ]==1]) 
#' # Returns for each item the names of sample sets where it is present. The opposite result for absent calls can be 
#' # returned by changing '==1' to '==0'.

check.packages <- function(pkg){
  new.pkg <- pkg[!(pkg %in% installed.packages()[, "Package"])]
  if (length(new.pkg))
    install.packages(new.pkg, dependencies = TRUE)
  sapply(pkg, require, character.only = TRUE)
}

# Usage example
packages<-c("ape", "tools", "optparse")
invisible(suppressMessages(check.packages(packages)))


# usgae
# Rscript ~/R_scripts/newick_tree/Tree2grouping.R -t human_gut_tree.newick

option_list = list(
  
  make_option(c("-t", "--tree"), 
              type="character", 
              default=NULL, 
              help="input file name", 
              metavar="character"));


opt_parser = OptionParser(option_list=option_list);
opt = parse_args(opt_parser);


tree_file_in = opt$tree
tree_file_in_name_no_extension = file_path_sans_ext(basename(tree_file_in))
pwd_tree_plot_file = paste(tree_file_in_name_no_extension, 'pdf', sep = '.')

# read in tree file
SCG_tree = read.tree(tree_file_in)

# plot input tree
SCG_tree = read.tree(tree_file_in)

SCG_tree_leaf_number = SCG_tree$tip.label
tree_height = length(SCG_tree_leaf_number)*15

pdf(pwd_tree_plot_file, width = 1600, height = tree_height)
#png(pwd_tree_plot_file, width = 1000, height = tree_height, pointsize = 30)
#jpeg(pwd_tree_plot_file, width = 1600, height = tree_height, units = "px", quality = 100, pointsize = 30)
#plot.phylo(SCG_tree, 'u', font = 1, cex = 1, label.offset = 0.01, lab4ut = 'axial')
plot.phylo(SCG_tree, type = 'phylogram', show.tip.label = TRUE, font = 1, cex = 0.5, no.margin = FALSE, align.tip.label = TRUE, plot = TRUE)  # Type: phylogram,cladogram, fan, unrooted, radial.
add.scale.bar(x= -1, y = 0)
dev.off()

library(circlize)

# mat = read.table('/Users/songweizhi/Dropbox/Research/MetaCHIP_manuscript/real_dataset/26bins_HGT_direction.txt', header = TRUE)

mat = read.table('/Users/songweizhi/Desktop/HGT_candidates_ET_validated_matrix.csv', header = TRUE)


grid.col = c(A = 'brown1', B = 'lawngreen', C = 'mediumorchid', D = 'mediumslateblue', E = 'royalblue', F = 'sandybrown')

chordDiagram(t(mat))
#chordDiagram(t(mat), grid.col = grid.col)

par(mar = rep(0,4), cex = 1.3)    

#for(si in get.all.sector.index()) {
#  circos.axis(h = "top", labels.cex = 0.3, sector.index = si, track.index = 2)
#}

circos.clear()

# Generalised linear models 2
# http://environmentalcomputing.net/generalised-linear-models-2/

library(mvabund)

Revegetation_data = '/Users/songweizhi/PycharmProjects/BioSAK/My_R_scripts/Environmental_Computing_tutorials/data/Revegetation.csv'
Reveg <- read.csv(Revegetation_data, header = T)
Reveg


hist(Reveg$Soleolifera)


ft.sol.pois <- manyglm(Soleolifera~Treatment, family="poisson", data=Reveg)
plot(ft.sol.pois)


ft.sol.nb <- manyglm(Soleolifera~Treatment,family="negative binomial",data=Reveg)
plot(ft.sol.nb)


anova(ft.sol.nb)
summary(ft.sol.nb)
ft.sol.nb$coefficients

boxplot(Soleolifera~Treatment,ylab = "Count", xlab = "Treatment", data=Reveg)

####################################### stat_Linear_Regression (DataCamp) #####################################

# https://www.datacamp.com/community/tutorials/linear-regression-R#coefficients

# Adding p values and R squared values to a plot using expression()
# http://lukemiller.org/index.php/2012/10/adding-p-values-and-r-squared-values-to-a-plot-using-expression/

#################################################### load data ################################################

library(readxl)
ageandheight <- read_excel("/Users/songweizhi/ageandheight.xls", sheet = "Hoja2") #Upload the data
ageandheight


########################################## Simple linear regression ###########################################

# Simple linear regression
lmHeight = lm(height~age, data = ageandheight) #Create the linear regression
summary(lmHeight) #Review the results


########################################## Multiple linear regression #########################################

# Multiple linear regression
lmHeight2 = lm(height~age + no_siblings, data = ageandheight) #Create a linear regression with two variables
summary(lmHeight2) #Review the results

# In general, for models that fit the data well, R² is near 1. Models that poorly fit the data have R² near 0.
# The adjusted R² is probably better to look at if you are adding more than one variable to the model


##################################################### Plot ####################################################

# plot the dots
plot(height~age, data = ageandheight, pch = 16, col = "blue") #Plot the results


# add the regression line
abline(lmHeight)


# get the value of r2 and p
regression_summary = summary(lmHeight)
r2 = regression_summary$adj.r.squared
p_value = regression_summary$coefficients[2,4]


# add r2 and p to the plot
rp = vector('expression',2)
rp[1] = substitute(expression(italic(R)^2 == MYVALUE), list(MYVALUE = format(r2,dig=3)))[2]
rp[2] = substitute(expression(italic(p) == MYOTHERVALUE), list(MYOTHERVALUE = format(p_value, digits = 2)))[2]
legend('topleft', legend = rp, bty = 'n')


# plot residuals
# Ideally, when you plot the residuals, they should look random. 
# Otherwise means that maybe there is a hidden pattern that the linear model is not considering.
plot(lmHeight$residuals, pch = 16, col = "red")

#################### afternoon session ####################

library(ggplot2)
library(gapminder)
library(ggrepel)
library(grid)
library(gridExtra)


file_in = '/Users/songweizhi/Desktop/gapminder_2016.csv'
plot_out = '/Users/songweizhi/Desktop/my_first_plot.png'

# read in data
gap_2016 = read.csv(file = file_in, header = T, sep = ',')


ggplot(gap_2016) +
  geom_point(aes(x = gdpPercap, y = lifeExp, color = continent)) +
  geom_smooth(aes(x = gdpPercap, y = lifeExp),
              size = 1, method = 'loess',
              color = 'red', alpha = 0.4)

gap_2016$my_labels <- gap_2016$country
gap_2016$my_labels[gap_2016$continent!= "Oceania"] <- NA

myplot = ggplot(gap_2016) +
  geom_point(aes(x=gdpPercap,y=lifeExp, color=continent, size=pop, alpha = 0.05)) +
  scale_size_continuous(range=c(0.5,20),name = "Population") + 
  labs(title = 'Gapminder DF 2016', 
       x = 'GDP/capita',
       y = 'Life Expectancy (years)') +
  theme(legend.position = 'right',
        plot.title = element_text(size = 20, face = 'bold'),
        axis.text.x = element_text(size = 10),
        axis.text.y = element_text(size = 10),
        axis.title.x = element_text(size = 10, face = 'bold'),
        axis.title.y = element_text(size = 10, face = 'bold')) +
  scale_color_discrete(name = 'Continent') +
  coord_cartesian(xlim = c(0, 150000), ylim =c(30, 90)) +
  scale_x_continuous(labels = c('0k', '50k', '100k', '150k')) +
  scale_y_continuous(breaks = seq(40, 85, 10)) +
  geom_text_repel(aes(x=gdpPercap, 
                      y = lifeExp, 
                      color = continent,
                      label = gap_2016$my_labels),
                  size = 3.5,
                  nudge_y = 0.3)
# save to file
ggsave(plot_out, plot = myplot, width = 12, height = 8, units = 'in')



# scale_color_grey in grey scale

# install GenomeInfoDbData first
source("https://bioconductor.org/biocLite.R")
biocLite("GenomeInfoDbData")

# update packages
update.packages('matrixStats')
update.packages('VGAM')

# install deepSNV (http://master.bioconductor.org/packages/devel/bioc/html/deepSNV.html), try http:// if https:// URLs are not supported
source("https://bioconductor.org/biocLite.R")
biocLite("deepSNV")

# load library
library(deepSNV)
?deepSNV

setwd('/Users/songweizhi/Desktop/deepSNV_bams')

test_bam = '2D9.bam'
control_bam = 'D2D0.bam'

# example 
regions = data.frame(chr="D2_p", start = 0, stop=1000000)

D2AD9 = deepSNV(test_bam, control_bam, regions=regions, q=25)
D2AD9

data(D2AD9)
show(D2AD9)
control(D2AD9)[100:110,]
test(D2AD9)[100:110,]
plot(D2AD9)
SNVs <- summary(D2AD9, sig.level=0.05, adjust.method="BH")
head(SNVs)
nrow(SNVs)
min(SNVs$freq.var)
sum(RF(test(D2AD9), total=T) > 0.01 & RF(test(D2AD9), total=T) < 0.95)
data(trueSNVs, package="deepSNV")
table(p.adjust(p.val(D2AD9), method="BH") < 0.05, trueSNVs)

######################################## Normalization ########################################

## Load data (unnormalized)
data(phiX, package="deepSNV")
plot(phiX, cex.min=.5)
## Normalize data
phiN <- normalize(phiX, round=TRUE) plot(phiN, cex.min=.5)
p.norm <- p.val(phiN)
## Normalize data
phiN <- normalize(phiX, round=TRUE) plot(phiN, cex.min=.5)
## Normalize data
phiN <- normalize(phiX, round=TRUE)
plot(phiN, cex.min=.5)
p.norm <- p.val(phiN)
n <- sum(!is.na(p.norm))
qqplot(p.norm, seq(1/n,1, length.out=n), log="xy", type="S", xlab="P-value", ylab="CDF")
p.val <- p.val(phiX)
points(sort(p.val[!is.na(p.val)]), seq(1/n,1, length.out=n), pch=16, col="grey", type="S", lty=2)
legend("topleft", c("raw data", "normalized data"), pch=16, col=c("grey", "black"), bty="n", lty= abline(0,1))
abline(0,1)

######################################## Overdispersion ########################################

data("RCC", package="deepSNV")
show(RCC)
plot(RCC, cex.min=.5)
RCC.bb = estimateDispersion(RCC, alternative="two.sided")
plot(RCC.bb, cex.min=.5)
RCC.bb@log.lik
RCC@log.lik
RCC.bb@log.lik - RCC@log.lik
log(4*nrow(test(RCC)))
summary(RCC, adjust.method="bonferroni")[,1:6]
tab <- summary(RCC.bb, adjust.method="bonferroni")[,1:6] tab
tab <- summary(RCC.bb, adjust.method="bonferroni")[,1:6]
tab

# check.packages function: install and load multiple R packages.
# Check to see if packages are installed. Install them if they are not, then load them into the R session.
check.packages <- function(pkg){
    new.pkg <- pkg[!(pkg %in% installed.packages()[, "Package"])]
    if (length(new.pkg))
        install.packages(new.pkg, dependencies = TRUE)
    sapply(pkg, require, character.only = 1)}

# install packages if not installed
packages<-c("optparse", "ape", "vegan")
invisible(suppressMessages(check.packages(packages)))

option_list = list(
  make_option(c("-a", "--treeo"),  type="character", default=NULL, help="the first tree"),
  make_option(c("-b", "--treet"),  type="character", default=NULL, help="the second tree"));

opt_parser = OptionParser(option_list=option_list);
opt = parse_args(opt_parser);

TREE1 = read.tree(opt$treeo)
TREE2 = read.tree(opt$treet)

D1 = cophenetic(TREE1)
D1 = D1[order(row.names(D1)),order(row.names(D1))]
D2 = cophenetic(TREE2)
D2 = D2[order(row.names(D2)),order(row.names(D2))]

mantel(xdis = D1, ydis = D2, permutations = 999)

library('seqinr')


fasta_file_in = '/Users/songweizhi/Desktop/seq_demo.fasta'
fasta_file_out = '/Users/songweizhi/Desktop/seq_demo_out.fasta'
ctgs_to_keep = list('seq_1', 'seq_3', 'seq_2')


# initialize fasta file
close(file(fasta_file_out, open = "w"))

for (each_seq in read.fasta(file = fasta_file_in, seqtype = 'DNA', as.string = TRUE, forceDNAtolower = 0)){
    each_seq_id = getName(each_seq)
    
    if (any(ctgs_to_keep == each_seq_id)){
      write.fasta(each_seq, each_seq_id, open = 'a', file.out = fasta_file_out)
    }
}  
  

install.packages("igraph")
library(igraph)
el1 = read.csv('/Users/weizhisong/Desktop/edges_list.csv', header = FALSE)
el2 = as.matrix(el1)
el2
graph_from_edgelist(el, directed = TRUE)


el <- matrix( c("foo", "bar", "bar", "foobar"), nc = 2, byrow = TRUE)
el
graph_from_edgelist(el, directed = TRUE)



tkplot(el)
from_edgelist(el, directed = TRUE)

graph_from_edgelist(el)
make_ring(2)
ring(el)

... = graph_from_edgelist(el)


?"igraph"

graph_from_edgelist(cbind(1:10, c(2:10, 1)))


str(make_ring(10))
str(make_ring(10, directed = TRUE, mutual = TRUE))


g <- graph_from_literal( Alice-Bob-Cecil-Alice, Daniel-Cecil-Eugene, Cecil-Gordon )
g

library(mvabund)

# Generalised linear models 1
# http://environmentalcomputing.net/generalised-linear-models-1/

Crabs_data = '/Users/songweizhi/PycharmProjects/BioSAK/My_R_scripts/Environmental_Computing_tutorials/data/Crabs.csv'

Crab_PA <- read.csv(Crabs_data, header = T)
Crab_PA

# To test whether the probability of crab presence changes with time (a factor) 
# and distance (a continuous variable), we fit the following model. 
# The response variable (presence/absence of crabs) is binomial, so we use family=binomial.
ft.crab <- glm(CrabPres ~ Time*Dist, family=binomial, data=Crab_PA)

# Assumptions of GLM
# Assumption 1 : The observed y are independent, conditional on some predictors x.
# Assumption 2 : The response y come from a known distribution with a known mean-variance relationship.
# To check Assumption 2, we look at a plot of residuals, and try to see if there is a fan shape.
plot(ft.crab,which=1)
# Unfortunately the glm plot function gives us a very odd looking plot due to the discreteness of the data.

# For a more useful plot we can instead fit the model using the manyglm function in the mvabund package.
ft.crab.many <- manyglm(CrabPres ~ Time*Dist, family="binomial", data=Crab_PA)
plot(ft.crab.many)
# there doesn’t seem to be a fan shape, so we can conclude the mean-variance assumption the model made was reasonable for our data.
# The residuals in this plot have a random component. If you see a pattern it’s best to repeat the plot a few times to see if the pattern is real.

# Assumption 3 : There is a straight line relationship between a known function g of the mean of y and the predictors x
# To check this assumption, we check the residual plot above for non-linearity, 
# or a U-shape. In our case there is no evidence of non-linearity. 
# If the residuals seem to go down then up, or up then down, we may need to 
# add a polynomial function of the predictors using the poly function.


# Interpreting the results
anova(ft.crab,test="Chisq")

anova(ft.crab.many)

summary(ft.crab)

library(ape)
library(vegan)

TREE1 = read.tree('/Users/songweizhi/Desktop/species_tree_denovo.newick')
TREE2 = read.tree('/Users/songweizhi/Desktop/species_tree_subset.newick')

D1 = cophenetic(TREE1)
D1 = D1[order(row.names(D1)),order(row.names(D1))]
D2 = cophenetic(TREE2)
D2 = D2[order(row.names(D2)),order(row.names(D2))]

mantel(xdis = D1, ydis = D2, permutations = 999)

# ICoVeR

source("http://bioconductor.org/biocLite.R")
biocLite("Biostrings")
install.packages("opencpu")
install.packages(devtools)


library(devtools)
library(opencpu)
install_local(file.path(getwd(), "R.ICoVeR"))

opencpu$stop() # It starts at a random port, which is annoying.
opencpu$start(8000)
browseURL("http://localhost:8000/ocpu/library/ICoVeR/www/", browser = getOption("browser"), encodeIfNeeded = FALSE)

################################# Normality Test  #################################

# Many of statistical tests including correlation, regression, t-test, and analysis of variance (ANOVA) assume some 
# certain characteristics about the data. They require the data to follow a normal distribution or Gaussian distribution. 
# These tests are called parametric tests, because their validity depends on the distribution of the data.

# Before using a parametric test, we should perform some preleminary tests to make sure that the test assumptions are met. 
# In the situations where the assumptions are violated, non-paramatric tests are recommended.

# Here, we’ll describe how to check the normality of the data by visual inspection and by significance tests.


################################# Load packages and Import data #################################

# Install required R packages
#install.packages("dplyr")
#install.packages("ggpubr")
library("dplyr")
library("ggpubr")


# Import data
my_data <- ToothGrowth
my_data


# print a random sample of 10 rows using the sample_n() function
set.seed(1234)
dplyr::sample_n(my_data, 10)


# Note!!!
# Case of large sample sizes:
# If the sample size is large enough (n > 30), we can ignore the distribution of the data and use parametric tests.
# The central limit theorem tells us that no matter what distribution things have, the sampling distribution tends 
# to be normal if the sample is large enough (n > 30).


# Normality can be checked by visual inspection [normal plots (histogram), Q-Q plot (quantile-quantile plot)] or by 
# significance tests].


################################# Normality test (Visual methods) #################################

# Visual methods: Density plot
library("ggpubr")
ggdensity(my_data$len, main = "Density plot of tooth length", xlab = "Tooth length")


# Visual methods: Q-Q plot
library("ggpubr")
ggqqplot(my_data$len)
# As all the points fall approximately along this reference line, we can assume normality.


################################# Normality test (Significance test) #################################

# Visual inspection is usually unreliable. It’s possible to use a significance test comparing the sample distribution 
# to a normal one in order to ascertain whether data show or not a serious deviation from normality.

# Shapiro-Wilk’s method is widely recommended for normality test and it provides better power than K-S. It is based on the 
# correlation between the data and the corresponding normal scores.

# The null hypothesis of these tests is that “sample distribution is normal”. If the test is significant, the distribution 
# is non-normal.

# Note that, normality test is sensitive to sample size. Small samples most often pass normality tests. Therefore, it’s 
# important to combine visual inspection and significance test in order to take the right decision.


# perform Shapiro-Wilk test
shapiro.test(my_data$len)
#  The p-value > 0.05 implying that the distribution of the data are not significantly different from normal distribution. 
# In other words, we can assume the normality.

suppressWarnings(library(ape))
suppressWarnings(library(tools))
suppressWarnings(library(optparse))

# usgae
# Rscript ~/R_scripts/newick_tree/add_group_to_tree.R -t species_tree.newick -g species_tree_grouping_modified.txt

option_list = list(
  
  make_option(c("-t", "--tree"), 
              type="character", 
              help="tree file", 
              metavar="character"),

  make_option(c("-g", "--grouping"), 
              type="character", 
              help="grouping file", 
              metavar="character"));

opt_parser = OptionParser(option_list=option_list);
opt = parse_args(opt_parser);
wd = getwd()
grouping_file = opt$grouping
tree_file_in = opt$tree

tree_file_in_name_no_extension = file_path_sans_ext(basename(grouping_file))
tree_txt_file_with_group = paste(tree_file_in_name_no_extension, 'with_group.txt', sep = '_')
tree_txt_file_only_group = paste(tree_file_in_name_no_extension, 'only_group.txt', sep = '_')
tree_plot_file_with_group = paste(tree_file_in_name_no_extension, 'with_group.jpg', sep = '_')
tree_plot_file_only_group = paste(tree_file_in_name_no_extension, 'only_group.jpg', sep = '_')
pwd_tree_txt_file_with_group = paste(wd, tree_txt_file_with_group, sep = '/')
pwd_tree_txt_file_only_group = paste(wd, tree_txt_file_only_group, sep = '/')
pwd_tree_plot_file_with_group = paste(wd, tree_plot_file_with_group, sep = '/')
pwd_tree_plot_file_only_group = paste(wd, tree_plot_file_only_group, sep = '/')

# read in grouping file
grouping_df = read.csv(grouping_file, header = FALSE)

# plot SCG tree with group
SCG_tree_with_group = read.tree(tree_file_in)
i = 1
for (i in 1:length(SCG_tree_with_group$tip.label)) {
  label_name = SCG_tree_with_group$tip.label[i]
  label_name_row_num = which(grouping_df$V2 == label_name)
  group_id = grouping_df$V1[label_name_row_num]
  SCG_tree_with_group$tip.label[i] = paste(group_id, SCG_tree_with_group$tip.label[i], sep = '_')
  i = i + 1}
# plot tree with group
jpeg(pwd_tree_plot_file_with_group, width = 1600, height = 1600, units = "px", quality = 100, pointsize = 30)
plot.phylo(SCG_tree_with_group, 'u', font = 1, cex = 0.7, label.offset = 0.02, lab4ut = 'axial')
dev.off()
# write.tree(SCG_tree_with_group, file=pwd_tree_txt_file_with_group)

# plot SCG tree only group
SCG_tree_only_group = read.tree(tree_file_in)
i = 1
for (i in 1:length(SCG_tree_only_group$tip.label)) {
  label_name = SCG_tree_only_group$tip.label[i]
  label_name_row_num = which(grouping_df$V2 == label_name)
  group_id = grouping_df$V1[label_name_row_num]
  SCG_tree_only_group$tip.label[i] = paste(group_id)
  i = i + 1}
# plot tree only group
jpeg(pwd_tree_plot_file_only_group, width = 1600, height = 1600, units = "px", quality = 100, pointsize = 30)
plot.phylo(SCG_tree_only_group, 'u', font = 1, cex = 0.7, label.offset = 0.02, lab4ut = 'axial')
dev.off()
# write.tree(SCG_tree_only_group, file=pwd_tree_txt_file_only_group)

library(gplots)
library(ape)
#dat <- read.tree(file="your/newick/file")
dat <- read.tree(text="((A:4.2,B:4.2):3.1,C:7.3);")

#####################################################################################################
## All Pairwise Intersects: to identify and cluster overlaps among two to thousands of sample sets ##
#####################################################################################################
setlist <- lapply(1:6, function(x) sample(letters, x, replace=TRUE)); names(setlist) <- paste("S", seq(along=setlist), sep="")

setlist

# To work with the following function, the sample sets (here 6) need to be stored in a list object (here 'setlist')
# where each component is named by a unique identifier (here S1-S6).
setlist <- sapply(setlist, unique)

setlist

olMA <- sapply(names(setlist), function(x) sapply(names(setlist), function(y) sum(setlist[[x]] %in% setlist[[y]]))); olMA
# Creates an intersect matrix for all pairwise sample comparisons stored in 'setlist'
olMA

typeof(olMA)
?heatmap.2
#heatmap.2(olMA, trace="none", col=colorpanel(40, "darkred", "orange", "yellow"), Colv='Rowv', Rowv="none", dendrogram="none")
heatmap.2(olMA, trace="none", col=colorpanel(40, "darkred", "orange", "yellow"), Colv='Rowv', Rowv="none")
heatmap.2(olMA, trace="none", col=colorpanel(40, "darkred", "orange", "yellow"))

# Hierarchical clustering of the rows and columns of the intersect matrix 'olMA'. The result is plotted as heatmap

# PNG format
png(filename=opt$plot, units="in", width=25, height=25, pointsize=12, res=150)

# SCG format
svg(filename=opt$plot , width=15, height=15, pointsize=12)

# EPS format
cairo_ps(filename=opt$plot, width=15, height=15, pointsize=12)

library(plotly)

plot_ly(z = volcano, type = "heatmap")

m <- matrix(rnorm(9), nrow = 3, ncol = 3)
plot_ly(z = m, x = c("a", "b", "c"), y = c("d", "e", "f"), type = "heatmap") # colorscale: "Hot", "Greys", "Greens"

# Custom colorscales
vals <- unique(scales::rescale(c(volcano)))
o <- order(vals, decreasing = FALSE)
cols <- scales::col_numeric("Blues", domain = NULL)(vals)
colz <- setNames(data.frame(vals[o], cols[o]), NULL)
plot_ly(z = volcano, colorscale = colz, type = "heatmap")

library(vegan)
library(dunn.test)


Sample = c(30,40,10,5,15)


df = NULL
for(i in 1:100){
  df = rbind(df, rrarefy(x = Sample, sample = 70))
}

df

boxplot(df)


G = c(rep("A", 100),rep("B", 100),rep("C", 100),rep("D", 100),rep("E", 100))
G
X = c(df[,1], df[,2], df[,3], df[,4], df[,5])
X

AOV = aov(X ~ G)
summary(AOV)
pairwise.t.test(x = X, g = G, p.adjust.method = "BH")

dunn.test(x = X, g = G)

# Introduction to mvabund
# http://environmentalcomputing.net/introduction-to-mvabund/

library(mvabund)


Herbivore_specialisation_data = '/Users/songweizhi/PycharmProjects/BioSAK/My_R_scripts/Environmental_Computing_ tutorials/data/Herbivore_specialisation.csv'


Herbivores <- read.csv(file = Herbivore_specialisation_data, header = TRUE)
Herbivores


Herb_spp <- mvabund(Herbivores[,5:11])
Herb_spp


par(mar=c(2,10,2,2)) # adjusts the margins
boxplot(Herbivores[,5:11],horizontal = TRUE,las=2, main="Abundance")


meanvar.plot(Herb_spp)


plot(Herb_spp~Herbivores$Habitat, cex.axis=0.8, cex=0.8)
# use transformation="no" to look at the raw abundance data
# plot(Herb_spp~Herbivores$Habitat, cex.axis=0.8, cex=0.8, transformation="no")

# The model syntax below fits our response variable 
# (the mvabund object Herb_spp with the 100 counts of 7 species) 
# to the predictor variable Habitat (type of algae).
mod1 <- manyglm(Herb_spp ~ Herbivores$Habitat, family="poisson")

# If the model is a good fit, we should see a random scatter of points.
plot(mod1)


# We can use the family argument to choose a distribution 
# which is better suited to our data. 
mod2 <- manyglm(Herb_spp ~ Herbivores$Habitat, family="negative_binomial")


# This residual plot is much better, there is now no discernible fan shape 
# and we will use this model for all further analysis.
plot(mod2)


# We can test the multivariate hypothesis of whether species composition 
# varied across the habitats by using the anova function.
anova(mod2)
# We can see from this table that there is 
# a significant effect of Habitat (LRT = 625, P = 0.001),


# To examine this further, and see which herbivore species are more likely 
# to be found on which algal species, we can run univariate tests for each 
# species separately.
anova(mod2, p.uni="adjusted")


# we can test more complex models. For example, to fit a model with both habitat and day or night
mod3 <- manyglm(Herb_spp ~ Herbivores$Habitat*Herbivores$DayNight, family="negative_binomial")
anova(mod3)
# You can see that the species composition of herbivores varies with habitat, but not between day and night.

# Independent samples t-tests
# http://environmentalcomputing.net/independent-samples-t-test/

River_pH_data = '/Users/songweizhi/PycharmProjects/BioSAK/My_R_scripts/Environmental_Computing_ tutorials/data/River_pH.csv'
River_pH <- read.csv(River_pH_data, header = T)
River_pH

t.test(pH ~ River_name, data = River_pH, var.equal = TRUE)


############################################################
#                 Assumptions to check                     #
############################################################

# Written 
# As a minimum, the observed t statistic, the P-value and the number of degrees of freedom 
# should be reported. For example, you could write “the pH was significantly higher in River 
# A than River B (independent samples t-test: t = 6.98, df = 18, P < 0.001)”.

############################################################
#                Communicating the results                 #
############################################################

# Visual
# Box plots or column graphs with error bars are effective ways of communicating the variation 
# in a single continuous response variable versus a single categorical predictor variable.

boxplot(pH~River_name, data = River_pH, xlab = "River name", ylab = "pH")

library(ggplot2) #load package
library(datasets) #load R datasets
library(gcookbook) #load gcookbook datasets 

heightweight #dataset

# Plots:
ggplot(heightweight, aes(x = ageYear, y = heightIn)) + geom_point(shape = 1) + geom_point(size = 2) #shape: geom_point(shape = 2), fill:geom_point(size = 1)
ggplot(heightweight, aes(x = ageYear, y = heightIn, shape = sex, color = sex)) + geom_point() #p77

# set 
ggplot(heightweight, aes(x = ageYear, y = heightIn, shape = sex, color = sex)) + geom_point() + 
  scale_shape_manual(values = c(1,3))
  scale_color_brewer(palette = 'set1') #p77
  
#use slightly larger points and use a shape scale with custom values
ggplot(heightweight, aes(x = ageYear, y = heightIn, shape = sex)) + geom_point(size =3) + scale_shape_manual(values = c(1,2))

# example command
# Rscript ~/R_scripts/deepSNV/get_SNVs.R -q D1.bam -c D0.bam -i test_ctg -s 1 -e 300
# Rscript ~/R_scripts/deepSNV/get_SNVs.R -q 2D9.bam -c D2D0.bam -i D2_c -s 1 -e 3000000

############################## install library ##############################

# # install GenomeInfoDbData first
# source("https://bioconductor.org/biocLite.R")
# biocLite("GenomeInfoDbData")
# 
# # update packages
# install.packages('matrixStats')
# install.packages('VGAM')
# update.packages('matrixStats')
# update.packages('VGAM')
# 
# # install deepSNV (http://master.bioconductor.org/packages/devel/bioc/html/deepSNV.html)
# # try http:// if https:// URLs are not supported
# source("https://bioconductor.org/biocLite.R")
# biocLite("deepSNV")

# load library
suppressMessages(suppressWarnings(library(tools)))
suppressMessages(suppressWarnings(library(optparse)))
suppressMessages(suppressWarnings(library(deepSNV)))

################################## optparse #################################

option_list = list(
  
  make_option(c("-q", "--query_bam"), 
              type="character", 
              default=NULL, 
              help="query bam file", 
              metavar="character"),
  
  make_option(c("-c", "--control_bam"), 
              type="character", 
              default=NULL, 
              help="control bam file", 
              metavar="character"),
  
  make_option(c("-i", "--ctg_id"), 
              type="character", 
              default=NULL, 
              help="contig id", 
              metavar="character"),
  
  make_option(c("-s", "--start_pos"), 
              type="integer", 
              default=NULL, 
              help="start position", 
              metavar="number"),
  
  make_option(c("-e", "--end_pos"), 
              type="integer", 
              default=NULL, 
              help="end position", 
              metavar="number"));

opt_parser = OptionParser(option_list=option_list);
opt = parse_args(opt_parser);
query_bam = opt$query_bam
control_bam = opt$control_bam
ctg_id = opt$ctg_id
start_pos = as.integer(opt$start_pos)
end_pos = as.integer(opt$end_pos)

# define file names
query_bam_path = dirname(query_bam)
query_bam_filename_no_extension = file_path_sans_ext(basename(query_bam))
control_bam_filename_no_extension = file_path_sans_ext(basename(control_bam))
SNV_output_jpg_file = paste(query_bam_filename_no_extension, 'vs', control_bam_filename_no_extension, ctg_id, start_pos, end_pos, 'SNVs.jpg', sep = '_')
SNV_output_txt_file = paste(query_bam_filename_no_extension, 'vs', control_bam_filename_no_extension, ctg_id, start_pos, end_pos, 'SNVs.txt', sep = '_')

################################## get SNV ##################################

# set regions
regions <- data.frame(chr=ctg_id, start = start_pos, stop = end_pos)
SNV_simulated <- deepSNV(test = query_bam, control = control_bam, regions=regions)
# plot(SNV_simulated)
# png(filename=SNV_output_jpg_file, units="in", width=30, height=30, pointsize=12, res=300)
png(filename=SNV_output_jpg_file)
plot(SNV_simulated)
invisible(dev.off())

# get summary
# SNVs <- summary(SNV_simulated, sig.level=0.05, adjust.method="BH")
SNVs <- summary(SNV_simulated)

# write out
write.table(SNVs, file = SNV_output_txt_file, row.names=FALSE, col.names = TRUE, sep = ',', quote = FALSE)

# https://www.datanovia.com/en/blog/top-r-color-palettes-to-know-for-great-data-visualization/

rainbow(20)

heat.colors(20)

terrain.colors(50)

topo.colors(20)

cm.colors(30)


color_selected = sample(terrain.colors(50), 1)

# Use 'scale' to normalize
heatmap(data, scale="column")


data2 = read.table("/Users/songweizhi/Desktop/mtcars.txt", row.names=1, header = TRUE, sep = "\t")
data2_matrix = as.matrix(data2)

heatmap(data2_matrix)

library(plotrix)

input_file = "/Users/songweizhi/Desktop/heatmap_plotrix_example_data.csv"

chromosome = read.csv(input_file, header = TRUE)
chromosome_matrix = as.matrix(chromosome[,-1])
rownames(chromosome_matrix) = chromosome[,1]

row_number = dim(chromosome_matrix)[1]
column_number = dim(chromosome_matrix)[2]

color2D.matplot(chromosome_matrix, 
                xlab="Genome", 
                ylab="COG category", 
                show.legend=T, 
                border=NA, 
                color.spec="rgb", 
                axes=FALSE,
                cs1=c(0,1), cs2=c(0,0), cs3=c(0,0) # control the color, see below a few examples
                )

axis(1,at=0.5:(column_number-0.5),labels=colnames(chromosome_matrix)) 
axis(2,at=(row_number - 0.5):0.5, labels=rownames(chromosome_matrix)) 

rownames(chromosome_matrix)
# black and red: cs1=c(0,1), cs2=c(0,0), cs3=c(0,0)
# archaea yellow: cs1=c(0,1), cs2=c(0,1), cs3=c(0,0)
# gamma purple: cs1=c(0,1), cs2=c(0,0), cs3=c(0,1)
# gamma red+yellow: cs1=c(1,1), cs2=c(1,0), cs3=c(0,0)
# c(0,1),c(1,0.6,0.4,0.3,0),c(0.1,0.6)

# clear variables/objects
rm(list=ls())

# Paired t-tests
# http://environmentalcomputing.net/paired-t-tests/

# Paired t-tests are used to compare the means of two groups of measurements when individual objects are measured twice.

# For example, to contrast the photosynthetic performance of ten plants in two environments in a greenhouse (shady and sunny), 
# we could measure performance in each individual plant twice, once in the shade and once in the sun. 

# The 20 individual measurements are not independent of each other because we would expect the pair of measurements taken from 
# the same individual to be more similar to each other than if randomly sampled from all available plants. We are thus unable 
# to use an independent samples t-test – that test would be appropriate if each plant was used only once, with some plants
# measured in the shady treatment and different set of plants measured in the sunny treatment.

# Pairing data like this is usually done to reduce the likely variation among measurements with the aim of better detecting 
# differences between groups. In this example, the difference between the two measures of photosynthetic performance on a given 
# plant should reflect mostly the effect of sunlight, while in an independent samples design, the difference between a plant in 
# the shade and another plant in the sun will reflect both differences in the effects of sunlight and differences between the 
# individual plants.


############################################################
#                 Running the analysis                     #
############################################################

Greenhouse_data = '/Users/songweizhi/PycharmProjects/BioSAK/My_R_scripts/Environmental_Computing_ tutorials/data/Greenhouse.csv'
Greenhouse <- read.csv(file = Greenhouse_data, header = TRUE)

# response variable (Performance) to the left of the ~, the predictor variable (Treatment) to the right of the ~.
t.test(Performance ~ Treatment, data = Greenhouse, paired = TRUE)


############################################################
#                 Assumptions to check                     #
############################################################

# Normality
# For a paired t-test, it is assumed the the sample of differences is normally distributed. If these are highly skewed, 
# transformations may be used to achieve a distribution closer to normal.

# Independence
# The paired design takes into account that the two measures from each pair are not independent. It is still important, 
# however, that each pair of objects measured are independent from other pairs. If they are linked in any way (e.g., groups 
# of plants sharing a water tray) then more complex analytical design that account for additional factors may be required.


############################################################
#                Communicating the results                 #
############################################################

# Written
# As a minimum, the observed t statistic, the P-value and the number of degrees of freedom should be reported. 
# For example, you could write “The photosynthetic performance of plants was significantly greater in sunny environments 
# in contrast to shady environments (paired t-test: t = 18.81, df = 9, P < 0.001)”.

# Visual
# Box plots or column graphs with error bars are effective ways of communicating the variation in a single continuous 
# response variable versus a single categorical predictor variable.
boxplot(Performance~Treatment, data = Greenhouse, xlab = "Light environment", ylab = "Photosynthetic performance (FvFm)")

library(circlize)

options(digits = 2)
mat1 = matrix(rnorm(25), nrow = 5)
rownames(mat1) = paste0("A", 1:5)
colnames(mat1) = paste0("B", 1:5)

mat2 = matrix(rnorm(25), nrow = 5)
rownames(mat2) = paste0("A", 1:5)
colnames(mat2) = paste0("C", 1:5)

mat3 = matrix(rnorm(25), nrow = 5)
rownames(mat3) = paste0("B", 1:5)
colnames(mat3) = paste0("C", 1:5)


mat = matrix(0, nrow = 10, ncol = 10)
rownames(mat) = c(rownames(mat2), rownames(mat3))
colnames(mat) = c(colnames(mat1), colnames(mat2))
mat[rownames(mat1), colnames(mat1)] = mat1
mat[rownames(mat2), colnames(mat2)] = mat2
mat[rownames(mat3), colnames(mat3)] = mat3

# Set larger gaps between groups. Here we manually adjust gap.after in circos.par().
circos.par(gap.after = rep(c(rep(1, 4), 8), 3))

chordDiagram(mat, annotationTrack = c("grid", "axis"),
             preAllocateTracks = list(
               track.height = uh(4, "mm"),
               track.margin = c(uh(4, "mm"), 0)
             ))

# highlight.sector(rownames(mat1), track.index = 1, col = "red",   text = "A", cex = 0.8, text.col = "white", niceFacing = TRUE)
# highlight.sector(colnames(mat1), track.index = 1, col = "green", text = "B", cex = 0.8, text.col = "white", niceFacing = TRUE)
# highlight.sector(colnames(mat2), track.index = 1, col = "blue",  text = "C", cex = 0.8, text.col = "white", niceFacing = TRUE)


print(rownames(mat1))
print(colnames(mat1))
print(colnames(mat2))

highlight.sector(c("A1", "A2", "A3", "A4", "A5"), track.index = 1, col = "lightblue", text = "A", cex = 0.8, text.col = "black", niceFacing = TRUE)
highlight.sector(c("B1", "B2", "B3", "B4", "B5"), track.index = 1, col = "lightblue", text = "B", cex = 0.8, text.col = "black", niceFacing = TRUE)
highlight.sector(c("C1", "C2", "C3", "C4", "C5"), track.index = 1, col = "lightblue", text = "C", cex = 0.8, text.col = "black", niceFacing = TRUE)

circos.clear()

rm(list=ls())

check.packages <- function(pkg){
    new.pkg <- pkg[!(pkg %in% installed.packages()[, "Package"])]
    if (length(new.pkg))
        install.packages(new.pkg, dependencies = TRUE)
    sapply(pkg, require, character.only = 1)
}


# install packages if not
packages<-c("optparse", "ggplot2")
invisible(suppressMessages(check.packages(packages)))


############################################### Usage example ##############################################

# !!! COG annotation results for the HGTs must be in the last one row
# Rscript ~/Dropbox/R_scripts/for_plot/COG_summary_boxplot_last1row.R -i matrix.csv -o plot.png

############################################################################################################

option_list = list(
  
  make_option(c("-i", "--input"), 
              type="character", 
              help="input file name", 
              metavar="character"),
  
  make_option(c("-o", "--out"), 
              type="character", 
              help="output plot name", 
              metavar="character")); 

opt_parser = OptionParser(option_list=option_list);
opt = parse_args(opt_parser);


############################################### read in data ###############################################

my_data = read.csv(opt$input, row.names = 1)

# remove columns with all zero values
my_data = my_data[, colSums(my_data != 0) > 0]

# slice dataframe
row_num = dim(my_data)[1]
input_genomes_COG = my_data[1:(row_num-1),]
HGT_COG = my_data[row_num,]


######################################### get shape and color list #########################################

shape_list  = c()
color_list  = c()
for(each_col in names(my_data)){
  each_col_quatile = quantile(my_data[each_col][1:(row_num-1),])
  each_col_quatile_low = each_col_quatile[[2]]
  each_col_quatile_high = each_col_quatile[[4]]
  each_col_HGT = my_data[each_col][row_num,]
  
  current_shape = ''
  current_color = ''
  if ((each_col_HGT - each_col_quatile_high) > 0){
    current_shape = 24
    current_color = 'firebrick2'
  } else if ((each_col_HGT - each_col_quatile_low) < 0){
    current_shape = 25
    current_color = 'deepskyblue'
  } else {
    current_shape = 22
    current_color = 'black'
  }
  # add current shape and color to their list
  shape_list = c(shape_list, current_shape)
  color_list = c(color_list, current_color)
}

################################################# get plot #################################################

png(filename=opt$out, units="in", width=9, height=6, pointsize=10, res=300)

ggplot() + 
  geom_boxplot(data = stack(my_data[1:(row_num-1),]), aes(x = ind, y = values)) + 
  
  geom_point(data = data.frame(x = factor(colnames(my_data)), 
                               y = as.numeric(my_data[row_num,])),
             aes(x=x, y=y),
             color = color_list, fill = color_list, 
             shape = shape_list,
             stroke = 0.8, size = 2.5) + 
  
  theme_bw() + # white background
  theme(panel.border = element_blank(), 
        panel.grid.major = element_blank(),
        panel.grid.minor = element_blank(), 
        axis.line = element_line(colour = "black"),
        axis.text.x = element_text(colour="black",size=6,angle=270,hjust=0,vjust=.5,face="plain"),
        axis.text.y = element_text(colour="black",size=6,angle=0,hjust=0,vjust=0,face="plain"),
        axis.title.x = element_text(colour="black",size=6,angle=0,hjust=.5,vjust=0,face="plain"),
        axis.title.y = element_text(colour="black",size=6,angle=90,hjust=.5,vjust=0,face="plain"))+
  labs(x = "COG category", y = 'Proportion') # label of x and y axis

invisible(dev.off())

# File:   BarCharts.R
# Course: R: An Introduction (with RStudio)

# LOAD DATASETS PACKAGES ###################################

library(datasets)

# LOAD DATA ################################################

?mtcars
head(mtcars)

# BAR CHARTS ###############################################

barplot(mtcars$cyl)             # Doesn't work

# Need a table with frequencies for each category
cylinders <- table(mtcars$cyl)  # Create table
barplot(cylinders)              # Bar chart
plot(cylinders)                 # Default X-Y plot (lines)

# CLEAN UP #################################################

# Clear environment
rm(list = ls()) 

# Clear packages
detach("package:datasets", unload = TRUE)  # For base

# Clear plots
dev.off()  # But only if there IS a plot

# Clear console
cat("\014")  # ctrl+L

# Clear mind :)

################################# Oneway ANOVA  #################################

# http://www.sthda.com/english/wiki/one-way-anova-test-in-r

install.packages("devtools")
install.packages("ggpubr")
library("devtools")
library("ggpubr")
library("ggplot2")
library("dplyr")


################################# load data #################################

my_data <- PlantGrowth
my_data
str(my_data)
summary(my_data)
head(my_data)
View(my_data) # if you use RStudio this is a nice way to see the data in spreadsheet format
levels(my_data$group)


################################# Visualize data #################################

boxplot(my_data$weight)
boxplot(my_data$weight~my_data$group, col= rainbow(4))

# If the levels are not automatically in the correct order, re-order them as follow:
my_data$group <- ordered(my_data$group, levels = c("ctrl", "trt1", "trt2"))


ggboxplot(my_data, x = "group", y = "weight", 
          color = "group", palette = c("#00AFBB", "#E7B800", "#FC4E07"),
          order = c("ctrl", "trt1", "trt2"),
          ylab = "Weight", xlab = "Treatment")

ggline(my_data, x = "group", y = "weight", 
       add = c("mean_se", "jitter"), 
       order = c("ctrl", "trt1", "trt2"),
       ylab = "Weight", xlab = "Treatment")

# Box plot
boxplot(weight ~ group, data = my_data,
        xlab = "Treatment", ylab = "Weight",
        frame = FALSE, col = c("#00AFBB", "#E7B800", "#FC4E07"))

# plotmeans
install.packages("gplots")
library("gplots")
plotmeans(weight ~ group, data = my_data, frame = FALSE,
          xlab = "Treatment", ylab = "Weight",
          main="Mean Plot with 95% CI") 


################################# Compute one-way ANOVA test #################################

# Compute the analysis of variance
res.aov <- aov(weight ~ group, data = my_data)

# Summary of the analysis
summary(res.aov)

# As the p-value is less than the significance level 0.05, we can conclude that there are significant 
# differences between the groups highlighted with “*" in the model summary.


#################### Multiple pairwise-comparison between the means of groups ####################

# In one-way ANOVA test, a significant p-value indicates that some of the group means are different, 
# but we don’t know which pairs of groups are different.

# It’s possible to perform multiple pairwise-comparison, to determine if the mean difference between 
# specific pairs of group are statistically significant.


##### Tukey multiple pairwise-comparisons #####

# As the ANOVA test is significant, we can compute Tukey HSD (Tukey Honest Significant Differences) 
# for performing multiple pairwise-comparison between the means of groups.
# The function TukeyHD() takes the fitted ANOVA as an argument.
TukeyHSD(res.aov)

# It can be seen from the output, that only the difference between trt2 and trt1 is significant with 
# an adjusted p-value of 0.012.


##### Multiple comparisons using multcomp package #####

# It’s possible to use the function glht() [in multcomp package] to perform multiple comparison procedures for an ANOVA. 
# glht stands for general linear hypothesis tests. The simplified format is as follow:

# glht(model, lincft)
# 1) model: a fitted model, for example an object returned by aov().
# 2) lincft(): a specification of the linear hypotheses to be tested. Multiple comparisons in ANOVA models 
#    are specified by objects returned from the function mcp().


# perform multiple pairwise-comparisons for a one-way ANOVA:
library('multcomp')
summary(glht(res.aov, linfct = mcp(group = "Tukey")))


##### Pairewise t-test #####

# The function pairewise.t.test() can be also used to calculate pairwise comparisons between group levels 
# with corrections for multiple testing.
pairwise.t.test(my_data$weight, my_data$group, p.adjust.method = "BH")

# The result is a table of p-values for the pairwise comparisons. Here, the p-values have been adjusted 
# by the Benjamini-Hochberg method.


################################# Check ANOVA assumptions #################################

# The ANOVA test assumes that, the data are normally distributed and the variance across groups are homogeneous.
# We can check that with some diagnostic plots.


##### Check the homogeneity of variance #####

# The residuals versus fits plot can be used to check the homogeneity of variances
plot(res.aov, 1)
# In the plot, there is no evident relationships between residuals and fitted values (the mean of each groups), 
# We can assume the homogeneity of variances.
# Points 17, 15, 4 are detected as outliers, which can severely affect normality and homogeneity of variance. 
# It can be useful to remove outliers to meet the test assumptions.


# Levene’s test for testing homogeneity of variances.
# It’s also possible to use Bartlett’s test or Levene’s test to check the homogeneity of variances.
# We recommend Levene’s test, which is less sensitive to departures from normal distribution. 
library(car)
leveneTest(weight ~ group, data = my_data)
# From the output above we can see that the p-value is not less than the significance level of 0.05. 
# This means that there is no evidence to suggest that the variance across groups is statistically significantly different. 
# Therefore, we can assume the homogeneity of variances in the different treatment groups.


##### Relaxing the homogeneity of variance assumption #####

# The classical one-way ANOVA test requires an assumption of equal variances for all groups.
# How do we save our ANOVA test, in a situation where the homogeneity of variance assumption is violated?
# An alternative procedure (i.e.: Welch one-way test), that does not require that assumption have been 
# implemented in the function oneway.test().

# ANOVA test with no assumption of equal variances
oneway.test(weight ~ group, data = my_data)

# Pairwise t-tests with no assumption of equal variances
pairwise.t.test(my_data$weight, my_data$group, p.adjust.method = "BH", pool.sd = FALSE)


##### Check the normality assumption #####

# Normality plot of residuals
plot(res.aov, 2)

# In the plot below, the quantiles of the residuals are plotted against the quantiles of the normal distribution. 
# A 45-degree reference line is also plotted.

# The normal probability plot of residuals is used to check the assumption that the residuals are normally distributed. 
# It should approximately follow a straight line.

# As all the points fall approximately along this reference line, we can assume normality.


# Significance test with Shapiro-Wilk
# Extract the residuals
aov_residuals <- residuals(object = res.aov )

# Run Shapiro-Wilk test
shapiro.test(x = aov_residuals )

library(ape)
library(tools)
library(optparse)



# read in tree file
SCG_tree = read.tree('/Users/songweizhi/Desktop/species_tree_with_grouping_3.newick')

# get distance matrix from input tree
distance_matrix = cophenetic(SCG_tree)

distance_matrix

write.csv(distance_matrix, '/Users/songweizhi/Desktop/species_tree_with_grouping_3.matrix')

#################### Dissimilarity Indices for Community Ecologists ####################

# load library
library(vegan)


# define a dataframe 
gold_fish = c(6, 10) 
guppies = c(7, 0) 
rainbow_fish = c(4, 6) 
data_frame = data.frame(gold_fish, guppies, rainbow_fish)
row.names(data_frame) = c('Tank1', 'Tank2')
data_frame

# Bray-Curtis dissimilarity
vegdist(data_matrix, method="bray")

library(vegan)
library(ggplot2)

annotation_wd = '/Users/songweizhi/Desktop/Kelp_coassembly/annotation'
sample_metadata = paste(annotation_wd, 'sample_metadata.txt', sep = '/')

annotation_file = paste(annotation_wd, 'df_dbcan_norm.txt', sep = '/')
#annotation_file = paste(annotation_wd, 'df_COG_id_norm.txt', sep = '/')   # id, cate
#annotation_file = paste(annotation_wd, 'df_KEGG_B_norm.txt', sep = '/')   # B, C, D



dbcan_annotation <- read.csv(file = annotation_file, header = TRUE, sep = '\t')

sample_metadata = read.csv(file = sample_metadata, header = TRUE, sep = '\t')
dbcan_annotation_values = dbcan_annotation[2:ncol(dbcan_annotation)]

dbcan.mds <- metaMDS(comm = dbcan_annotation_values, distance = "bray", trace = FALSE, autotransform = TRUE)

MDS_xy <- data.frame(dbcan.mds$points)
MDS_xy$Location <- sample_metadata$Location
MDS_xy$Replicate <- sample_metadata$Replicate
MDS_xy$Month <- sample_metadata$Month
ggplot(MDS_xy, aes(MDS1, MDS2, color = Location, shape = Replicate)) + geom_point()

#################### Diversity Indices for Community Ecologists ####################

# load library
library(vegan)

?procrustes


# define a dataframe 
library(ape)
library(vegan)

TREE1 = read.tree('/Users/songweizhi/Desktop/species_tree_1.0.newick')
TREE2 = read.tree('/Users/songweizhi/Desktop/species_tree_0.4.newick')

D1 = cophenetic(TREE1)
D1 = D1[order(row.names(D1)),order(row.names(D1))]
D2 = cophenetic(TREE2)
D2 = D2[order(row.names(D2)),order(row.names(D2))]

procrustes_summary = procrustes(D1, D2)
summary(procrustes_summary)

plot(procrustes_summary)
plot(procrustes_summary, kind=2)
residuals(procrustes_summary)

install.packages("networkD3")
install.packages('curl')
library(networkD3)
library(curl)



URL <- paste0("https://cdn.rawgit.com/christophergandrud/networkD3/", "master/JSONdata/energy.json") 
energy <- jsonlite::fromJSON(URL) 
energy
sankeyNetwork(Links = energy$links, Nodes = energy$nodes, Source = "source", Target = "target", Value = "value", NodeID = "name", units = "TWh", fontSize = 12, nodeWidth = 30)
energy$links$energy_type <- sub(" .*", "", energy$nodes[energy$links$source + 1, "name"]) sankeyNetwork(Links = energy$links, Nodes = energy$nodes, Source = "source", Target = "target", Value = "value", NodeID = "name", LinkGroup = "energy_type", NodeGroup = NULL )

library(assertr) # to Concatenate all columns of each row in data frame


bin_subfolder = 'home/Desktop'
bin_subfolder
bin_subfolder_split = strsplit(bin_subfolder, '/')
bin_subfolder_split

needed = bin_subfolder_split[[1]][-1]
needed
typeof(bin_subfolder_split)



m0 <- matrix(NA, 4, 0)
rownames(m0)
m0

m2 <- cbind(1, 1:4)
colnames(m2, do.NULL = FALSE)
colnames(m2) <- c("x","Y")
rownames(m2) <- rownames(m2, do.NULL = FALSE, prefix = "Obs.")
m2


my_df <- data.frame(matrix(ncol = 3, nrow = 0))
colnames(my_df)  = c("MetaBAT", "MyCC", "CONCOCT")
my_df['lima', 'MyCC'] = 'aa'
my_df['song', 'MetaBAT'] = 'bb'
my_df['lima', 'MetaBAT'] = 'cc'
my_df['lima', 'CONCOCT'] = 3
my_df['bins', 'MyCC'] = 'bb'
my_df['song', 'CONCOCT'] = 1
my_df['bins', 'CONCOCT'] = 10
my_df

my_df_reordered = my_df[order(my_df$CONCOCT),]
my_df_reordered






my_df$na_count <- apply(my_df, 1, function(x) sum(is.na(x)))
my_df

my_df$concate = ifelse(apply(my_df, 1, function(x) sum(is.na(x))) == 0, col_concat(my_df, sep = '___'), NA)
my_df


my_df$concate = ifelse(is.na(my_df) == TRUE, col_concat(my_df, sep = '___'), NA)
my_df


my_df$concate = ifelse(any(is.na(my_df) == TRUE) == TRUE, col_concat(my_df, sep = '___'), NA)
my_df


my_df$concate = col_concat(my_df, sep = '___')
my_df


if (any(is.na(my_df) == TRUE) == TRUE){
  my_df$concate= col_concat(my_df, sep = '___')
} else {
  my_df$concate = NA
}

my_df$concate[any(is.na(my_df) == TRUE) == TRUE] = col_concat(my_df, sep = '___')
my_df





my_df$song

any(my_df$song == <NA>)

?any


my_str = c(1,2,3,4)

any(my_df['lima',] == 1)


any(is.na(c(1,2,NA)))

    
    
any(is.na(my_df['song',]) == TRUE) == TRUE

df <- data.frame(B=c("A","B","C","C"), C=c("A","C","B","B"), D=c("B","A","C","A") )
df
df$A<-ifelse(df$B==df$C,paste(df$D),paste(df$C))

return(df)

library('seqinr')
library('rlist')


setwd('/Users/songweizhi/Desktop/Binning_refiner_R_wd2')
input_bin_folder = 'input_bin_folder'
input_bin_folder


file_out = 'contigs2bin.tab'

# get input_bin_subfolders
input_bin_subfolders = list.dirs(input_bin_folder, recursive=FALSE)
input_bin_subfolders


# get contig to bin information
file_out_handle = file(file_out, open = "w")

# initialize a dataframe
ctg_to_bin_df <- data.frame(matrix(ncol = 3, nrow = 0))
colnames(ctg_to_bin_df)  = c("MetaBAT", "MyCC", "CONCOCT")


# read in contig to bin information
for (bin_subfolder in input_bin_subfolders){
  bin_file_list = list.files(bin_subfolder)
  for (each_bin in bin_file_list){
    pwd_each_bin = paste(bin_subfolder, each_bin, sep = '/')
    for (each_seq in read.fasta(file = pwd_each_bin, seqtype = 'DNA', as.string = 1, forceDNAtolower = 0)){
      
      # get sequence id
      each_seq_id = getName(each_seq)
      
      # remove path from bin_subfolder
      bin_subfolder_only_name = strsplit(bin_subfolder, '/')[[1]][-1]
      
      # turn what to write out into dataframe
      for_write_df = data.frame(each_seq_id, bin_subfolder_only_name, each_bin)
      
      # write out into file
      write.table(for_write_df, file_out_handle, row.names = FALSE, col.names = FALSE, quote = FALSE, sep = ",")
      
    }
  }
}

# close file
close(file_out_handle)

ctg_to_bin_df


#read in contig to bin file 

# contig2bin_matrix = read.csv(file_out)
# 
# print(contig2bin_matrix)
# 




# ##########################################################################################
# #                                        FOR TEST                                        #
# ##########################################################################################
# 
# for_test = list(a=c(1,'b',3), b=NULL)
# for_test
# 
# if (exists('c', where=for_test) == TRUE){
#   for_test$a = c(for_test$a, 555)
# } else {
#   for_test = list.append(for_test, c=c('haha'))
# }
# 
# for_test
# 
# ##########################################################################################
# ##########################################################################################
# 
# 
# 
# #bin_folders = list.dirs(path = ".", all.files = FALSE)
# bin_folders = c('MetaBAT', 'MyCC')
# 
# file_out = file('bin_contigs.tab', open = "w")
# 
# for (each_folder in bin_folders){
#   
# #  # create tmp folder
# #  each_folder_tmp = paste(each_folder, '_tmp', sep = '')
# #  if(file.exists(each_folder_tmp)){
# #    unlink(each_folder_tmp, recursive = TRUE)
# #    dir.create(each_folder_tmp)
# #  }else{
# #    dir.create(each_folder_tmp)
# #  }
#   
#   # get bin file list
#   current_bins = list.files(each_folder)
#   
#   # read in sequences
#   for(each_bin in current_bins){
#     pwd_each_bin = paste(each_folder, each_bin, sep = '/')
#     each_bin_seqs = read.fasta(file = pwd_each_bin, seqtype = 'DNA', as.string = 1, forceDNAtolower = 0)
#     current_bin_seq_list = c(each_bin)
#     print(typeof(current_bin_seq_list))
#     for (each_seq in each_bin_seqs){
#       seq_id = getName(each_seq)
#       current_bin_seq_list = c(current_bin_seq_list, seq_id)
#     }
#     print(current_bin_seq_list)
#     print(typeof(current_bin_seq_list))
#     
#     to_write = paste(toString(current_bin_seq_list), sep = ',')
#     print(to_write)
#     
#     write.csv(to_write, file = file_out)
#     
#   }
# }
# 
# close(file_out)
# 
# 
# 
# 
# # if (exists('each_seq_id', where=seq_lol) == FALSE) {
# #   seq_lol = list.append(seq_lol, each_seq_id=c(each_bin))
# # } else {
# #   seq_lol$each_seq_id = c(seq_lol$each_seq_id, each_bin)
# # }

# install phyloseq
source('http://bioconductor.org/biocLite.R')
biocLite('phyloseq')

library(phylobase)
library(phyloseq)
library(ape)



data(geospiza)
nodeLabels(geospiza) <- paste("N", nodeId(geospiza, "internal"), sep="")
geotree <- extractTree(geospiza)

class(geotree)
plot(geotree)

GTDB_tree = readNewick('/Users/songweizhi/Desktop/arc122_r86.1.tree')
SCG_tree = readNewick('/Users/songweizhi/Desktop/GoodBins_0.5_0.05_species_tree.newick')

class(SCG_tree)

plot(SCG_tree)
?readNewick

# tips <- c("difficilis", "fortis", "fuliginosa", "fusca", "olivacea", "pallida", "parvulus", "scandens")
tips <- c('psittacula', 'parvulus', 'pallida', 'pauper', 'fusca')
tree_subset = subset(geotree, tips.include=tips)
plot(tree_subset)


GTDB_tree = read.tree('/Users/songweizhi/Desktop/arc122_r86.1.tree')
class(GTDB_tree)

taxon_to_keep = c('GB_GCA_002725245.1', 'GB_GCA_002496725.1', 'GB_GCA_002687305.1')
GTDB_tree_subset = subset(GTDB_tree, tips.include=taxon_to_keep)


?subset
plot(GTDB_tree_subset)


GTDB_tree_subset2 = prune_samples(taxon_to_keep, GTDB_tree)

??prune_samples

################################# stat_Linear_Regression #################################

# http://r-statistics.co/Linear-Regression.html


######################################## load data #######################################

cars


###################################### Scatter Plot ######################################

scatter.smooth(x=cars$speed, y=cars$dist, main="Dist ~ Speed")  # scatterplot


############################## BoxPlot – Check for outliers ##############################

# divide graph area in 2 columns
par(mfrow=c(1, 2))  

# box plot for 'speed'
boxplot(cars$speed, main="Speed", sub=paste("Outlier rows: ", boxplot.stats(cars$speed)$out))  

# box plot for 'distance'
boxplot(cars$dist, main="Distance", sub=paste("Outlier rows: ", boxplot.stats(cars$dist)$out))  


###################################### Density plot ######################################

# To check if the response variable is close to normality

# load library
library(e1071)

# divide graph area in 2 columns
par(mfrow=c(1, 2))  

# density plot for 'speed'
plot(density(cars$speed), main="Density Plot: Speed", ylab="Frequency", sub=paste("Skewness:", round(e1071::skewness(cars$speed), 2)))  
polygon(density(cars$speed), col="red")

# density plot for 'dist'
plot(density(cars$dist), main="Density Plot: Distance", ylab="Frequency", sub=paste("Skewness:", round(e1071::skewness(cars$dist), 2)))  
polygon(density(cars$dist), col="red")


####################################### Correlation ######################################

# calculate correlation between speed and distance 
cor(cars$speed, cars$dist)  


################################### Build Linear Model ###################################

# build linear regression model on full data
linearMod <- lm(dist ~ speed, data=cars)  
print(linearMod)


############################## Linear Regression Diagnostics #############################

# print the summary statistics for obtained linear model
modelSummary <- summary(linearMod)
modelSummary

# model p-Value (bottom last line: p-value: 1.49e-12)
# p-Value of individual predictor variables (extreme right column under ‘Coefficients’)

# The p-Values are very important because, We can consider a linear model to be statistically 
# significant only when both these p-Values are less that the pre-determined statistical 
# significance level, which is ideally 0.05.

# get individual values

# get model coefficients
modelCoeffs <- modelSummary$coefficients 
modelCoeffs

library(ggplot2)
library(ggcorrplot)
library(reshape)

mydata <- mtcars[, c(1,3,4,5,6,7)]

head(mydata)

cormat <- round(cor(mydata),2)

head(cormat)
typeof(cormat)

setwd('/Users/songweizhi/Desktop/heatmap_test')

mydata = read.csv('ANI.txt', header = TRUE, sep=",",row.names = 1)
mydata

p.mat <- cor_pmat(mydata)
ggcorrplot(mydata)



#mydata_matrix <- as.matrix(mydata)
#class(mydata_matrix)
#heatmap(mydata_matrix)

# Generate decending values from 100 to 1 to simulate retention over time
rcohorts <- replicate(15, sort(runif(15, 1, 100), T))

# Make a triangle
rcohorts[lower.tri(rcohorts)] <- NA

# Convert to a data frame, and add tenure labels
rcohorts <- as.data.frame(rcohorts)
rcohorts$tenure <- seq(0,14)

# Reshape to suit ggplot, remove NAs, and sort the labels
rcohorts <- na.omit(melt(rcohorts, 'tenure', variable_name='cohort'))
rcohorts$cohort <- factor(rcohorts$cohort, levels=rev(levels(rcohorts$cohort)))
#The data shows a particular value for a given cohort across a number of weeks.
head(rcohorts)


ggplot(rcohorts, aes(cohort, tenure)) +
  ggtitle('Retention by cohort') +
  theme_bw() +
  xlab('Cohort') +
  ylab('Tenure (weeks)') +
  geom_tile(aes(fill = value), color='white') +
  scale_fill_gradient(low = 'white', high = 'darkblue', space = 'Lab') +
  theme(axis.text.x=element_text(angle=90),
        axis.ticks=element_blank(),
        axis.line=element_blank(),
        panel.border=element_blank(),
        panel.grid.major=element_line(color='#eeeeee'))

######################### cat() and print() ########################

cat("a","b","c")
cat("a","b","c",sep=",",fill=TRUE)
cat("a","b","c",sep="\t",fill=TRUE)

# specify a width after which a new line is inserted
cat("a","b","c",fill=2)
cat("a","b","c",fill=4)




######################### manipulate number #########################

round(3.1415, digits = 2)
# 3.14




#################### for loop and if statements ####################

sum = 0

for (i in 1:5){
  
  if (i >= 3){
    sum = sum + i
  }
  
}

print(sum)




#################### for loop and if statements ####################

# class()      - what kind of object is it (high-level)?
# typeof()     - what is the object’s data type (low-level)?
# length()     - how long is it? What about two dimensional objects?
# attributes() - does it have any metadata?


list_demo = c(1, 2.5, -3, '4', 'good', NA, NaN, TRUE)

for (i in list_demo){
  
  print(i)
  print(class(i))
  cat('\n')
  
}


print(class(1.1))

################################# One_Sample_T_test  #################################

# Link: http://www.sthda.com/english/wiki/one-sample-t-test-in-r


# Definition 
# one-sample t-test is used to compare the mean of one sample to a known standard (or theoretical/hypothetical) mean (μ).


# Generally, the theoretical mean comes from:
# 1) a previous experiment. For example, compare whether the mean weight of mice differs from 200 mg, a value determined 
#    in a previous study.
# 2) or from an experiment where you have control and treatment conditions. If you express your data as “percent of control”, 
#    you can test whether the average value of treatment condition differs significantly from 100.


# Note!!!
# One-sample t-test can be used only, when the data are normally distributed . This can be checked using Shapiro-Wilk test .


# Typical research questions are:
# 1) whether the mean (m) of the sample is equal to the theoretical mean (μ)?
# 2) whether the mean (m) of the sample is less than the theoretical mean (μ)?
# 3) whether the mean (m) of the sample is greater than the theoretical mean (μ)?

# In statistics, we can define the corresponding null hypothesis (H0) as follow:
# H0:m=μ
# H0:m≤μ
# H0:m≥μ

# The corresponding alternative hypotheses (Ha) are as follow:
# Ha:m≠μ (different)
# Ha:m>μ (greater)
# Ha:m<μ (less)

# If the p-value is inferior or equal to the significance level 0.05, we can reject the null hypothesis and accept 
# the alternative hypothesis. In other words, we conclude that the sample mean is significantly different from the 
# theoretical mean.


################################# Visualize data and compute one-sample t-test #################################

# install.packages("ggpubr")
# library('ggpubr')


# Here, we’ll use an example data set containing the weight of 10 mice, We want to know, if the average weight of the mice 
# differs from 25g?


# generate data
set.seed(1234)
my_data <- data.frame(name = paste0(rep("M_", 10), 1:10),weight = round(rnorm(10, 20, 2), 1))


# Check your data
head(my_data, 10) # print the first 10 rows
summary(my_data$weight) # Statistical summaries of weight
# Min.: the minimum value
# 1st Qu.: The first quartile. 25% of values are lower than this.
# Median: the median value. Half the values are lower; half are higher.
# 3rd Qu.: the third quartile. 75% of values are higher than this.
# Max.: the maximum value


# Visualize data with box plots
boxplot(my_data$weight)


################################# Preleminary test to check one-sample t-test assumptions #################################

# Is this a large sample? - No, because n < 30.
# Since the sample size is not large enough (less than 30, central limit theorem), we need to check whether the data 
# follow a normal distribution.


# check whether the data follow a normal distribution.
shapiro.test(my_data$weight)
# From the output, the p-value is greater than the significance level 0.05 implying that the distribution of the data 
# are not significantly different from normal distribtion. In other words, we can assume the normality.


# Visual inspection of the data normality using Q-Q plots (quantile-quantile plots). Q-Q plot draws the correlation 
# between a given sample and the normal distribution.
library("ggpubr")
ggqqplot(my_data$weight, ylab = "Weight", ggtheme = theme_minimal())

# From the normality plots, we conclude that the data may come from normal distributions.
# Note that, if the data are not normally distributed, it’s recommended to use the non parametric 
# one-sample Wilcoxon rank test.


################################# Compute one-sample t-test #################################

# One-sample t-test
res <- t.test(my_data$weight, mu = 25)
res 
# t is the t-test statistic value (t = -9.078),
# df is the degrees of freedom (df= 9),
# p-value is the significance level of the t-test (p-value = 7.95310^{-6}).
# conf.int is the confidence interval of the mean at 95% (conf.int = [17.8172, 20.6828]);
# sample estimates is he mean value of the sample (mean = 19.25).


#Access to the values returned by t.test() function
res$p.value # print the p-value
res$estimate # print the mean


# Test whether the mean weight of mice is less than 25g (one-tailed test)
res_2 = t.test(my_data$weight, mu = 25, alternative = "less")
res_2


# Test whether the mean weight of mice is greater than 25g (one-tailed test)
res_3 = t.test(my_data$weight, mu = 25, alternative = "greater")
res_3

install.packages("riverplot")
library(riverplot)
nodes <- c( LETTERS[1:3] )
edges <- list( A= list( C= 10 ), B= list( C= 10 ) )
r <- makeRiver( nodes, edges, node_xpos= c( 1,1,2 ),
                node_labels= c( A= "Node A", B= "Node B", C= "Node C" ),
                node_styles= list( A= list( col= "yellow" )) )
plot( r )
# equivalent form:
nodes <- data.frame( ID= LETTERS[1:3],
                     x= c( 1, 1, 2 ),
                     col= c( "yellow", NA, NA ),
                     labels= c( "Node A", "Node B", "Node C" ),
                     stringsAsFactors= FALSE )
r <- makeRiver( nodes, edges )
plot( r )
# all nodes but "A" will be red:
r <- makeRiver( nodes, edges, default_style= list( col="red" ) )
plot( r )
# overwrite the node information from "nodes":
r <- makeRiver( nodes, edges, node_styles= list( A=list( col="red" ) ) )
plot( r )



data( minard )
minard
nodes <- minard$nodes
edges <- minard$edges
colnames( nodes ) <- c( "ID", "x", "y" )
colnames( edges ) <- c( "N1", "N2", "Value", "direction" )
# color the edges by troop movement direction
edges$col <- c( "#e5cbaa", "black" )[ factor( edges$direction ) ]
# color edges by their color rather than by gradient between the nodes
edges$edgecol <- "col"
# generate the riverplot object and a style
river <- makeRiver( nodes, edges )
style <- list( edgestyle= "straight", nodestyle= "invisible" )
# plot the generated object
plot( river, lty= 1, default_style= style )
# Add cities
with( minard$cities, points( Longitude, Latitude, pch= 19 ) )
with( minard$cities, text( Longitude, Latitude, Name, adj= c( 0, 0 ) ) )


x <- riverplot.example() 
plot(x) 
plot(x, srt=90, lty=1)




nodes <- c( LETTERS[1:3] ) 
edges <- list( A= list( C= 10 ), B= list( C= 10 ) ) 
r <- makeRiver( nodes, edges, node_xpos= c( 1,1,2 ), node_labels= c( A= "Node A", B= "Node B", C= "Node C" ), node_styles= list( A= list( col= "yellow" )) ) 
plot( r )

# equivalent form: 
nodes <- data.frame( ID= LETTERS[1:3], x= c( 1, 1, 2 ), col= c( "yellow", NA, NA ), labels= c( "Node A", "Node B", "Node C" ), stringsAsFactors= FALSE ) 
r <- makeRiver( nodes, edges ) 
plot( r ) 
# all nodes but "A" will be red: 
r <- makeRiver( nodes, edges, default_style= list( col="red" ) ) 
plot( r ) 
# overwrite the node information from "nodes": 
r <- makeRiver( nodes, edges, node_styles= list( A=list( col="red" ) ) ) 
plot( r )





# To view the default style specification, type
default.style()
ex <- riverplot.example()
ex
ds <- default.style()
ds
plot( ex, default_style= ds )
# nodes with unspecified style will now be semi-transparent red:
ds[["col"]] <- "#FF000099"
plot( ex, default_style= ds )

library(gplots)   # contains the heatmap.2 package
library(car)   

States
dim(States)

scaled <- scale(States[,-1]) # scale all but the first column to make information comparable
heatmap.2(scaled, # specify the (scaled) data to be used in the heatmap
          cexRow=0.5, cexCol=0.95, # decrease font size of row/column labels
          scale="none", # we have already scaled the data
          trace="none") # cleaner heatmap

Author:"Marwan Majzoub"
Description:"This file contains all the commands for further analysis of the OTU table"
Date:"30/05/2021"

library("ggplot2")
library("vegan")
library("reshape")
library("gridExtra")
library("tidyverse")
library("dplyr")
library(RColorBrewer)
library(picante)
library(seqinr)
library(drc)
library(lattice)
library(permute)


# Read otu table
AllSamples <- read.delim("coloring_rarefaction_curves_otu_table.txt")
#another way to read the OTU table
#otu_table = t(read.delim('otu_table.txt', row.names = 1))

#RArefaction curve
#OTU Table only
otu_table <- dplyr::select(AllSamples, -OTU_ID)
otu_table <- as.matrix(t(otu_table))
colnames(otu_table) <- AllSamples[,1]

#sample with lowest no of seqs
raremax <- min(rowSums(otu_table))

####################################################################################

out <- rarecurve(otu_table, step=50, label=T,ylab = "OTU Count")

rare <- lapply(out, function(x){
  b <- as.data.frame(x)
  b <- data.frame(OTU = b[,1], raw.read = rownames(b))
  b$raw.read <- as.numeric(gsub("N", "",  b$raw.read))
  return(b)
})

names(rare) <- rownames(otu_table)

rare <- map_dfr(rare, function(x){
  z <- data.frame(x)
  return(z)
}, .id = "sample")

ggplot(data = rare)+
  geom_line(aes(x = raw.read, y = OTU, color = sample)) +
  geom_text(data = rare %>% #here we need coordinates of the labels
              group_by(sample) %>% #first group by samples
              summarise(max_OTU = max(OTU), #find max OTU
                        max_raw = max(raw.read)), #find max raw read
            aes(x = max_raw, y = max_OTU, label = sample), check_overlap = T, hjust = 0)+
  scale_x_continuous(labels =  scales::scientific_format()) +
  labs(colour = "black", x = "Sample Size", y = "OTU Count")

####################################################################################

#!/usr/bin/env Rscript

######################################## Usage ########################################

# usgae
# Rscript add_group_to_tree.R -t input_tree.newick -g grouping_file.txt

#######################################################################################


# check.packages function: install and load multiple R packages.
# Check to see if packages are installed. Install them if they are not, then load them into the R session.
check.packages <- function(pkg){
    new.pkg <- pkg[!(pkg %in% installed.packages()[, "Package"])]
    if (length(new.pkg))
        install.packages(new.pkg, dependencies = TRUE)
    sapply(pkg, require, character.only = TRUE)
}

# Usage example
packages<-c("ape", "tools", "optparse")
invisible(suppressMessages(check.packages(packages)))


option_list = list(
  
  make_option(c("-t", "--tree"),        type="character", help="tree file",                         metavar="character"),
  make_option(c("-g", "--grouping"),    type="character", help="grouping file (group_id,bin_id)",   metavar="character"));

opt_parser = OptionParser(option_list=option_list);
opt = parse_args(opt_parser);
grouping_file = opt$grouping
tree_file_in = opt$tree
tree_file_path = dirname(tree_file_in)

tree_file_in_name_no_extension = file_path_sans_ext(basename(grouping_file))
tree_txt_file_with_group = paste(tree_file_in_name_no_extension, 'with_group.tree', sep = '_')
tree_txt_file_only_group = paste(tree_file_in_name_no_extension, 'only_group.tree', sep = '_')

pwd_tree_txt_file_with_group = paste(tree_file_path, tree_txt_file_with_group, sep = '/')
pwd_tree_txt_file_only_group = paste(tree_file_path, tree_txt_file_only_group, sep = '/')

# read in grouping file
grouping_df = read.csv(grouping_file, header = FALSE)


#################### get tree with group ####################

SCG_tree_with_group = read.tree(tree_file_in)
i = 1
for (i in 1:length(SCG_tree_with_group$tip.label)) {
  label_name = SCG_tree_with_group$tip.label[i]
  label_name_row_num = which(grouping_df$V2 == label_name)
  group_id = grouping_df$V1[label_name_row_num]
  SCG_tree_with_group$tip.label[i] = paste(group_id, SCG_tree_with_group$tip.label[i], sep = '_')
  i = i + 1}

# write out tree
write.tree(SCG_tree_with_group, file=pwd_tree_txt_file_with_group)


#################### get tree with group only ####################

SCG_tree_only_group = read.tree(tree_file_in)
i = 1
for (i in 1:length(SCG_tree_only_group$tip.label)) {
  label_name = SCG_tree_only_group$tip.label[i]
  label_name_row_num = which(grouping_df$V2 == label_name)
  group_id = grouping_df$V1[label_name_row_num]
  SCG_tree_only_group$tip.label[i] = paste(group_id)
  i = i + 1}

# write out tree
write.tree(SCG_tree_only_group, file=pwd_tree_txt_file_only_group)

# library(optparse)
# library(ggplot2)
# library(plotrix)
# library(plsgenomics)
# library(ape)

check.packages <- function(pkg){
  new.pkg <- pkg[!(pkg %in% installed.packages()[, "Package"])]
  if (length(new.pkg))
    install.packages(new.pkg, dependencies = TRUE)
  sapply(pkg, require, character.only = 1)
}

# Usage example
packages<-c("optparse", "ggplot2", "plotrix", "plsgenomics", "ape")
check.packages(packages)


options(warn=-1)

option_list = list(
  
  make_option(c("-t", "--tree"), 
              type="character", 
              help="input GTDB tree subset", 
              metavar="character"),
  
  make_option(c("-m", "--matrix"), 
              type="character", 
              help="HGT matrix", 
              metavar="character"),
  
  make_option(c("-p", "--plot"), 
              type="character", 
              help="output plot", 
              metavar="character"));

opt_parser = OptionParser(option_list=option_list);
opt = parse_args(opt_parser);

SCG_tree = read.tree(opt$tree)
HGT_df = read.csv(opt$matrix, sep=",", row.names = 1, header = TRUE) 
plot_file = opt$plot

# group level
# SCG_tree = read.tree("/Users/songweizhi/Desktop/subset_tree_c.newick")
# HGT_df = read.csv("/Users/songweizhi/Desktop/plot_c/HGT_matrix_group_level_norm.csv", sep=",", row.names = 1, header = TRUE) 
# plot_file = '/Users/songweizhi/Desktop/plot_c/HGT_matrix_group_level_norm.png'


# convert df into matrix
HGT_mat = as.matrix(HGT_df)
HGT_mat
# transpose dataframe
#HGT_mat = t(HGT_mat)
SCG_tree$tip
# re-order matrix labels according to SCG tree
HGT_mat_adj <- HGT_mat[SCG_tree$tip, SCG_tree$tip]


png(filename=plot_file, units="in", width=15, height=15, pointsize=12, res=300)

# set the position of x and y labels
xl <- c(0.5, ncol(HGT_mat_adj)+0.5)
yl <- c(0.5, nrow(HGT_mat_adj)+0.5)

# set layout
layout(matrix(c(0,1,0,2,3,4,0,5,0),nrow=3, byrow=TRUE),width=c(1,3,1), height=c(1,3,1))
#layout(matrix(c(0,0,1,0,0,0,2,0,3,4,5,6,0,0,7,0),nrow=4, byrow=TRUE),width=c(1,0.5,3,1), height=c(1,0.5,3,1))

# plot tree on top
par(mar=rep(0,4))
plot(SCG_tree, direction="downwards", show.tip.label=FALSE, xaxs="i", x.lim=xl)

# # group ID label on top
# par(mar=rep(0,4))
# #plot(NA, axes=FALSE, ylim=c(2,2), xlim=xl,  xaxs="i") #
# plot(NA, axes=FALSE, ylim=c(0,2), xlim=xl,  xaxs="i") #
# text(1:ncol(HGT_mat_adj),rep(2,ncol(HGT_mat_adj)), SCG_tree$tip, pos=4, srt = -90)

# plot tree on left
par(mar=rep(0,4))
plot(SCG_tree, direction="rightwards", show.tip.label=FALSE, yaxs="i", y.lim=rev(yl))

# # group ID label
# par(mar=rep(0,4))
# plot(NA, axes=FALSE, xlim=c(0,2), ylim=yl, yaxs="i") # 
# text(rep(0,nrow(HGT_mat_adj)),1:nrow(HGT_mat_adj),rev(SCG_tree$tip), pos=4)
 
     
# plot matrix
par(mar=rep(0,4), xpd=TRUE)
#image((1:nrow(HGT_mat))-0.5, (1:ncol(HGT_mat))-0.5, HGT_mat, axes=FALSE) # xaxs="i", yaxs="i"
#matrix.heatmap(HGT_mat)
#color2D.matplot(HGT_mat_adj, show.legend=F, border=NA, show.values=3, color.spec="rgb", axes=FALSE, cs1=c(0,1), cs2=c(1,0), cs3=c(0,0))
#color2D.matplot(HGT_mat_adj, show.legend=F, border=NA, show.values=3, color.spec="rgb", axes=FALSE)
color2D.matplot(HGT_mat_adj, show.legend=F, border=NA, show.values=0, color.spec="rgb", axes=FALSE)

# plot Y-axis labels
par(mar=rep(0,4))
plot(NA, axes=FALSE, xlim=c(0,2), ylim=yl, yaxs="i") # 
text(rep(0,nrow(HGT_mat_adj)),1:nrow(HGT_mat_adj),rev(SCG_tree$tip), pos=4)

# plot X-axis label
par(mar=rep(0,4))
#plot(NA, axes=FALSE, ylim=c(2,2), xlim=xl,  xaxs="i") #
plot(NA, axes=FALSE, ylim=c(0,2), xlim=xl,  xaxs="i") #
text(1:ncol(HGT_mat_adj),rep(2,ncol(HGT_mat_adj)), SCG_tree$tip, pos=4, srt = -90)

invisible(dev.off())
#rm(list=ls())

eg_logical <- c(T, T, T, F, F) 
eg_integer <- c(1L, 6L, 1L, 5L, 4L)
eg_numeric <- c(0, 2.3, 2.45, 2.99, -1.1)
eg_character <- c("NSW", "NSW", "ACT", "WA", "WA")
eg_factor <- factor(c("NSW", "NSW", "ACT", "WA", "WA"))


print(eg_character)
print(eg_factor)
levels(eg_factor)

#################### Diversity Indices for Community Ecologists ####################

# load library
library(vegan)


?diversity


# define a dataframe 
species_abundance = c(2, 8, 1, 1, 3)
data_frame = data.frame(species_abundance)
row.names(data_frame) = c('apple', 'banana', 'orange', 'peach', 'pear')
data_frame


# Shannon diversity
diversity(data_frame, index = 'shannon')


# Simpson diversity
diversity(species_abundance, index = 'simpson')
diversity(data_frame, index = 'simpson')

library(diverse)
data_frame_t = t(data_frame)
data_frame_t
diversity(data_frame_t, type = "simpson")

# One sample t-tests
# http://environmentalcomputing.net/one-sample-t-test/

pollen <- c(94,135,78,98,137,114,114,101,112,121)
t.test(pollen, mu = 125)


############################################################
#                 Assumptions to check                     #
############################################################

# Normality
# The t distribution describes paramaters sampled from a normal population, so assumes 
# that the data are normally distributed. Note however that t-tests are reasonably robust 
# to violations of normality (although watch out for the influence of outliers).

# Independence
# The observations should have been sampled randomly from a defined population so that 
# sample mean is an unbiased estimate of the population mean. If individual replicates 
# are linked in any way, then the assumption of independence will be violated.


############################################################
#                Communicating the results                 #
############################################################

# Written 
# As a minimum, the observed t statistic, the p value and the number of degrees of freedom 
# should be reported. 
# For example, you could write “The mean pollen count from the footprints (109 ) was 
# significantly lower than expected if it was derived from the nearby forest with an 
# average count of 125 (t = 3.07, df = 9, P = 0.01)”.

# Visual
# Box plots or frequency histograms can be used to visualise the variation in a single variable. 
# In this example, you might use a line or arrow to indicate the single value (125) that you were 
# comparing the sample to.

hist(pollen,main=NULL)
abline(v=125,col="red")

boxplot(pollen,xlab = "Pollen count",horizontal =TRUE)
abline(v=125,col="red")

install.packages('pastecs')
library(pastecs)

identities = c(1,2,3,4,5,3,2,3,4,3,3,4)
abund(identities)
identities
plot(abund(identities))
data(bnr)
bnr
bnr.abd <- abund(bnr)
plot(bnr.abd, dpos=c(105, 100))

# zeta-diversity
library(zetadiv)

# Exploring zeta-diversity
# https://indradecastro.github.io/globalremoval/docs/20180525.zeta.html#read-data

# Measuring continuous compositional change using decline and decay in zeta diversity



utils::data(bird.spec.coarse)
xy.bird <- bird.spec.coarse[1:2]
data.spec.bird <- bird.spec.coarse[3:193]
dev.new(width = 12, height = 4)
zeta.bird <- Zeta.decline.mc(data.spec.bird, orders = 1:3, sam=100, plot = FALSE)
Plot.zeta.decline(zeta.bird)


zeta_demo_df <- read.csv(file = '/Users/songweizhi/Desktop/zeta_demo.txt', header = TRUE, sep = '\t')
value.demo = zeta_demo_df[2:ncol(zeta_demo_df)]
zeta.demo <- Zeta.decline.mc(value.demo, orders = 1:3, sam=100, plot = FALSE)
Plot.zeta.decline(zeta.demo)

# Tax4Fun2 was developed by Dr Bernd Wemheuer, this is only a short script showing how it can be installed and executed for functional prediction.

#######################################################################################################################
############################################# Section 1: install Tax4Fun2 #############################################
#######################################################################################################################

# source code of Tax4Fun2 (Tax4Fun2_1.1.5.tar.gz) is available here:
# https://github.com/songweizhi/BioSAK/tree/master/BioSAK_tutorial/Tax4Fun2

# There are two approaches to install Tax4Fun2 on you computer

# Approach 1:
# open RStudio > Tools > install packages > from "Install from" select "Package Archive File" > choose Tax4Fun2_1.1.5.tar.gz > Install

# Approach 2:
# Copy the source code Tax4Fun2_1.1.5.tar.gz to the folder where you want Tax4Fun2 to be installed.
# Here we are going to install it to the "Software" folder under my home directory
# Forward to the "Software" folder
cd /Users/songweizhi/Software
# paste the following two lines in your terminal to install Tax4Fun2
R
install.packages(pkgs = "Tax4Fun2_1.1.5.tar.gz", repos = NULL, source = TRUE)


#######################################################################################################################
############################################# Section 2: before you start #############################################
#######################################################################################################################

# You'll need to have Tax4Fun2's default database (Tax4Fun2_ReferenceData_v2) to perform functional prediction
# It's can be found in torsten/Weizhi_Song/Software_Scripts_Databases/Tax4Fun2/Tax4Fun2_ReferenceData_v2.tar.gz in Torsten's storage

# There are two ways of running Tax4Fun2
# refers to section 3 if you want to make functional predictions with Tax4Fun2's default database
# refers to section 4 if you want to make functional predictions with Tax4Fun2's default database together with a user-generated database


#######################################################################################################################
######################### Section 3: Making functional predictions using the default database #########################
#######################################################################################################################

library(Tax4Fun2)

# modify the following 8 lines
pwd_op_folder   = 'path/to/Tax4Fun2_output_folder'      # specify output folder
query_otu_seq   = 'path/to/demo_OTU.fasta'              # OTU sequence file
query_otu_table = 'path/to/demo_OTU_table.csv'          # OTU table
pwd_ref_data    = 'path/to/Tax4Fun2_ReferenceData_v2'   # path to Tax4Fun2's default database (i.e., Tax4Fun2_ReferenceData_v2), need to be decompressed before use
norm_by_cn      = TRUE                                  # normalize_by_copy_number (TRUE or FALSE)
norm_path       = TRUE                                  # normalize_pathways (TRUE or FALSE)
iden            = 0.97                                  # min_identity_to_reference
num_of_threads  = 6                                     # number of CPU cores to use 

# Run Tax4Fun2
runRefBlast(path_to_otus = query_otu_seq, path_to_reference_data = pwd_ref_data, path_to_temp_folder = pwd_op_folder, database_mode = "Ref99NR", use_force = T, num_threads = num_of_threads)
makeFunctionalPrediction(path_to_otu_table = query_otu_table, path_to_reference_data = pwd_ref_data, path_to_temp_folder = pwd_op_folder, database_mode = "Ref99NR", normalize_by_copy_number = norm_by_cn, min_identity_to_reference = iden, normalize_pathways = norm_path)


#######################################################################################################################
########## Section 4: Making functional predictions using the default database and a user-generated database ##########
#######################################################################################################################

# Please refers to steps in section 4.1 to generate your own database.
# You'll need to store your reference genomes/MAGs in a folder and provide full path to that folder to Tax4Fun2 with "pwd_user_data".
# You also need to specify a name to the to-be generated database with "name_user_data".
# !!! Reference genomes/MAGs without 16S rRNA genes will be ignored in database building.
# !!! You need to know the copy number of 16S rRNA genes in your reference genomes/MAGs, MarkerMAG might be able to help with this.

# I have created a user database with MAGs derived from sponge-associated microbial community.
# located at torsten/Weizhi_Song/Software_Scripts_Databases/Tax4Fun2/Sponge_associated_MAGs_with_added_16S.tar.gz
# To use it, replace the corresponding lines in section 4.2 with
# pwd_user_data  = 'path/to/Sponge_associated_MAGs_with_added_16S'
# name_user_data = 'Sponge_associated_MAGs_Tax4Fun2_db'

# Tahsin Khan has created a user database with Ecklonia radiata-associated MAGs,
# located at torsten/Weizhi_Song/Software_Scripts_Databases/Tax4Fun2/Ulva_MAGs_w16S.tar.gz
# To use it, replace the corresponding lines in section 4.2 with
# pwd_user_data  = 'path/to/Ulva_MAGs_w16S'
# name_user_data = 'Ulva_MAGs_db'

# Database files need to be decompressed before use
# tar -xzvf Sponge_associated_MAGs_with_added_16S.tar.gz
# tar -xzvf Ulva_MAGs_w16S.tar.gz

library(Tax4Fun2)

################## 4.1 use the following lines to Generate your own reference database ##################

# modify the following 4 lines
pwd_ref_data    = 'path/to/Tax4Fun2_ReferenceData_v2'   # path to Tax4Fun2's default database, need to be decompressed before use
pwd_user_data   = 'path/to/your/genome_folder'          # path to the folder holds the reference genome/MAG files
name_user_data  = 'name_of_user_database'               # specify the name of the generated database, specify only the name, do not include path here!
gnm_ext         = 'fna'                                 # extension of the genome files, normally in fasta, fna or fa

# Generate your own database
extractSSU(genome_folder = pwd_user_data, file_extension = gnm_ext, path_to_reference_data = pwd_ref_data)
assignFunction(genome_folder = pwd_user_data, file_extension = gnm_ext, path_to_reference_data = pwd_ref_data, num_of_threads = num_threads, fast = TRUE)
generateUserData(path_to_reference_data = pwd_ref_data, path_to_user_data = pwd_user_data, name_of_user_data = name_user_data, SSU_file_extension = "_16SrRNA.ffn", KEGG_file_extension = "_funPro.txt")

###### 4.2 making functional predictions using the default database and the user-generated database ######

# modify the following 10 lines
pwd_op_folder   = 'path/to/Tax4Fun2_output_folder'      # specify output folder
query_otu_seq   = 'path/to/demo_OTU.fasta'              # OTU sequence file
query_otu_table = 'path/to/demo_OTU_table.csv'          # OTU table
pwd_ref_data    = 'path/to/Tax4Fun2_ReferenceData_v2'   # need to be the same as in 4.1
pwd_user_data   = 'path/to/your/genome_folder'          # need to be the same as in 4.1
name_user_data  = 'name_of_user_database'               # need to be the same as in 4.1 , specify only the name, do not include path here
norm_by_cn      = TRUE                                  # normalize_by_copy_number (TRUE or FALSE)
norm_path       = TRUE                                  # normalize_pathways (TRUE or FALSE)
iden            = 0.97                                  # min_identity_to_reference
num_of_threads  = 6                                     # number of CPU cores to use 

# Run Tax4Fun2 with your data included
runRefBlast(path_to_otus = query_otu_seq, path_to_reference_data = pwd_ref_data, path_to_temp_folder = pwd_op_folder, database_mode = "Ref99NR", use_force = T, num_threads = num_of_threads, include_user_data = T, path_to_user_data = pwd_user_data, name_of_user_data = name_user_data)
makeFunctionalPrediction(path_to_otu_table = query_otu_table, path_to_reference_data = pwd_ref_data, path_to_temp_folder = pwd_op_folder, database_mode = "Ref99NR", normalize_by_copy_number = norm_by_cn, min_identity_to_reference = iden, normalize_pathways = norm_path, include_user_data = T, path_to_user_data = pwd_user_data, name_of_user_data = name_user_data)

### Dependencies: 

blast+ or diamond

### Annotation with NCBI blastp (default, for small dataset)

    BioSAK KEGG -db_dir path/to/your/KEGG_db_dir -t 6 -seq_in input.faa -depth input.depth

### Annotation with Diamond blastp (for big dataset)

    BioSAK KEGG -db_dir path/to/your/KEGG_db_dir -t 12 -seq_in faa_folder -x faa -depth depth_files -diamond

### Get summary for BlastKOALA/GhostKOALA produced results

    BioSAK KEGG -db_dir path/to/your/KEGG_db_dir -t 9 -ko_in user_ko.txt
    BioSAK KEGG -db_dir path/to/your/KEGG_db_dir -t 9 -ko_in user_ko_folder -x txt

### Prepare DB files, you need to have the following three files in your KEGG_db_dir:

1. Sequence file, only needed for "-seq_in" mode, DECOMPRESS and RENAME it to kegg_db_seq.fasta
   e.g. prokaryotes.pep.gz (https://www.kegg.jp/kegg/download/Readme/README.fasta)
2. seq2ko file, only needed for "-seq_in" mode, DECOMPRESS and RENAME it to kegg_db_seq2ko.txt
   e.g. prokaryotes.dat.gz (https://www.kegg.jp/kegg/download/Readme/README.fasta)
3. ko00001.keg
   https://www.genome.jp/kegg-bin/download_htext?htext=ko00001&format=htext&filedir=

### seq2ko file format(tab separated)
aaa:Acav_4596	K05375
zpr:ZPR_0691	K21572

### How it works:
1. KEGG module uses Blast+/Diamond to get the best hits of query genes in the database with user defined e-value cutoff (default 0.001).
2. The TotalDepth of a KO is calculated by summing up the depth of all genes assigned to it.
3. The percentage of GeneNumber/TotalDepth of genes assigned to a KO is calculated by dividing them 
   by the total number/depth of genes with KO assignment (default) or by all genes in a genome ("-pct_by_all"). 

### Note!!!
1. If you run KEGG annotation for multiple files in a batch manner and want to have their depth info incorporated into the results, 
   you need to provide a folder containing individual depth files for each of your input sequence file.
   Name of the depth file needs to be exactly the same as its corresponding sequence file, except the extension which is ".depth".
2. Diamond requires quite a lot of memory for sequence comparison, especially for huge db file (e.g. KEGG db).
   Remember to request sufficient memory (e.g. 90 or 120gb) in your job script and specify a small number (e.g. -t 6) 
   of jobs executing in parallel. Otherwise, you may see some of your query genomes with no gene been annotated.

### Depth file format (one gene per line, tab separated)
gene_1	30
gene_2	10.58

+ To do:
1. level C stats: separate stats for Pathway, Brite and the rests

    BioSAK SubsampleLongReads -i LongReads.fastq -s 5 -o op_dir_5 -fq
    BioSAK SubsampleLongReads -i LongReads.fastq -s 1,5,10 -o op_dir_1-10 -fq
    BioSAK SubsampleLongReads -i LongReads.fastq -s 1,25,50,75 -o op_dir_1-75 -fq

---
title: "TT"
author: "Weizhi Song"
date: "18 May 2016"
output: html_document
---

This is an R Markdown document. Markdown is a simple formatting syntax for authoring HTML, PDF, and MS Word documents. For more details on using R Markdown see <http://rmarkdown.rstudio.com>.

When you click the **Knit** button a document will be generated that includes both content as well as the output of any embedded R code chunks within the document. You can embed an R code chunk like this:


You can also embed plots, for example:

```{r, echo=FALSE}
plot(cars)]]]
```

Note that the `echo = FALSE` parameter was added to the code chunk to prevent printing of the R code that generated the plot.

    module load samtools
    BioSAK sam2bam -sam input.sam -t 12

# This is a wrapper for the following three steps:
    samtools view -bS input.sam -o input.bam
    samtools sort input.bam -o input_sorted.bam
    samtools index input_sorted.bam

# simulate 100000 pairs of reads from ref.fa
BioSAK Reads_simulator -p Test -r ref.fa -l 250 -i 300 -split -n 100000

# simulate reads to a depth of 50X
BioSAK Reads_simulator -p Test -r ref.fa -l 250 -i 300 -split -d 50

+ Dependencies
  + hmmer

+ annotate protein sequences

      BioSAK dbCAN -m P -t 6 -db_dir path/to/your/dbCAN_db_dir -i recipient.faa 
      BioSAK dbCAN -m P -t 6 -db_dir path/to/your/dbCAN_db_dir -i recipient.faa -depth recipient.depth
      BioSAK dbCAN -m P -t 6 -db_dir path/to/your/dbCAN_db_dir -i faa_files -x faa
      BioSAK dbCAN -m P -t 6 -db_dir path/to/your/dbCAN_db_dir -i faa_files -x faa -depth depth_files

+ annotate DNA sequences

      BioSAK dbCAN -m N -t 6 -db_dir /srv/scratch/z5039045/DB/dbCAN_V9 -i recipient.ffn
      BioSAK dbCAN -m N -t 6 -db_dir /srv/scratch/z5039045/DB/dbCAN_V9 -i ffn_files -x ffn

+ Prepare DB files (versions V9):

      cd path/to/your/dbCAN_db_dir
      wget http://bcb.unl.edu/dbCAN2/download/Databases/V9/hmmscan-parser.sh
      wget http://bcb.unl.edu/dbCAN2/download/Databases/V9/CAZyDB.07302020.fam-activities.txt
      wget http://bcb.unl.edu/dbCAN2/download/Databases/V9/dbCAN-HMMdb-V9.txt
      mv CAZyDB.07302020.fam-activities.txt CAZyDB.fam-activities.txt
      mv dbCAN-HMMdb-V9.txt dbCAN-fam-HMMs.txt
      hmmpress dbCAN-fam-HMMs.txt

+ How it works:
1. http://bcb.unl.edu/dbCAN2/download/Databases/dbCAN-old@UGA/readme.txt
2. The TotalDepth of a CAZy family is calculated by summing up the depth of all genes assigned to it.
3. The percentage of GeneNumber/TotalDepth of genes assigned to a CAZy family is calculated by dividing it 
   by the summation of GeneNumber/TotalDepth of all identified CAZy families. 

+ Note!!!
If you run dbCAN for multiple files in a batch manner and want to have their depth info incorporated into the results, 
you need to provide a folder containing individual depth files for each of your input sequence file.
Name of the depth file needs to be exactly the same as its corresponding sequence file, except the extension which is ".depth".

+ Depth file format (one gene per line, tab separated)
gene_1	30
gene_2	10.58

BioSAK plot_sam_depth -r ref.fa -d 12D9.bam.depth
BioSAK plot_sam_depth -r ref.fa -d 12D9.bam.depth -i contig_01 -s 100 -e 900 -k 300 -l 500,550,600

# get depth file 
module load samtools/1.15
samtools depth 12D9.bam > 12D9.bam.depth

BioSAK rename_reads_for_Reago -in Soil_R1.fasta -out Soil_R1_renamed.fasta -p Soil -d 1
BioSAK rename_reads_for_Reago -in Soil_R2.fasta -out Soil_R2_renamed.fasta -p Soil -d 2

# Note
1. The order of paired reads in the two paired reads files must be the same.
2. Prefix of renamed reads (-p) for the two paired reads files must be the same.

### Dependencies
  + blast+
  + diamond

### Annotate protein sequences

      BioSAK COG2020 -m P -t 6 -db_dir path/to/your/COG_db_dir -i genes.faa 
      BioSAK COG2020 -m P -t 6 -db_dir path/to/your/COG_db_dir -i faa_files -x faa -depth depth_files

### Annotate DNA sequences (ORFs)

      BioSAK COG2020 -m N -t 6 -db_dir path/to/your/COG_db_dir -i genes.ffn -depth gene.depth
      BioSAK COG2020 -m N -t 6 -db_dir path/to/your/COG_db_dir -i ffn_files -x ffn

### Prepare DB files (version 2020):

      cd path/to/your/COG_db_dir
      wget https://ftp.ncbi.nih.gov/pub/COG/COG2020/data/cog-20.fa.gz
      wget https://ftp.ncbi.nih.gov/pub/COG/COG2020/data/cog-20.cog.csv
      wget https://ftp.ncbi.nih.gov/pub/COG/COG2020/data/cog-20.def.tab
      wget https://ftp.ncbi.nih.gov/pub/COG/COG2020/data/fun-20.tab
      wget https://ftp.ncbi.nih.gov/pub/COG/COG2020/data/Readme.2020-11-25.txt
      gunzip cog-20.fa.gz
      module load blast
      makeblastdb -in cog-20.fa -dbtype prot -parse_seqids -logfile cog-20.fa.log
      module load diamond
      diamond makedb --in cog-20.fa --db cog-20.fa.dmnd --quiet

### How it works:
1. COG2020 module uses Blast+/Diamond to get the best hits of query genes in the database 
   with users defined e-value cutoff (default 0.001).

1. The TotalDepth of a COG id/category is obtained by summing up the depth of all genes assigned to it.

1. The percentage of GeneNumber/TotalDepth of genes assigned to a COG is calculated by dividing them 
   by the total number/depth of genes with COG assignment (default) or all query genes in a file (if "-pct_by_all" specified). 

### Note!!!

If you run COG2020 for multiple files in a batch manner and want to have their depth info incorporated into the results, 
you need to provide a folder containing individual depth file for each of your input sequence file.
Name of the depth file needs to be exactly the same as its corresponding sequence file, except the extension is ".depth".

#### Depth file format (one gene per line, tab separated)

    gene_1	30
    gene_2	10.58

### Description 



### Example commands

+ Extract reads for a single MAG

      BioSAK get_MAG_reads_long -r LongReads.fastq -s assembly.sam -m MAG_1.fa -o MAG_1_reads
    
+ Extract reads for multiple MAGs

      BioSAK get_MAG_reads_long -r LongReads.fastq -s assembly.sam -m MAG_dir -x fa -o extracted_reads -l 0

+ Extract reads for multiple MAGs, ignore reads shorter than 5000 bp

      BioSAK get_MAG_reads_long -r LongReads.fastq -s assembly.sam -m MAG_dir -x fa -o extracted_reads -l 5000


### Notes

+ The input sam file is obtained by mapping quality-filtered reads to all (not a subset of) contigs derived 
   from these reads (e.g., flye produced assembly.fasta).


+ The input MAGs and Sam file need to be generated from the same set of contigs (without renaming).


+ When a read is assigned to contigs from multiple MAGs, it will be added to the extracted reads for each of those MAGs.


+ If you use minimap2 for reads mapping, you might want to specify "--secondary=no" to minimise low-quality secondary alignments:

      minimap2 -d assembly.fasta.mmi assembly.fasta
      minimap2 --secondary=no -t 6 -a assembly.fasta.mmi long_reads.fastq > assembly.sam

If you are an UNSW Katana user, please install BioSAK with:

       ######### Install BioSAK with Python's virtual environment ########

       module load python/3.7.3
       mkdir ~/mypython3env_BioSAK
       python3 -m venv --system-site-packages ~/mypython3env_BioSAK
       source ~/mypython3env_BioSAK/bin/activate
       pip3 install BioSAK

       ####################### For later running #########################

       module load python/3.7.3
       source ~/mypython3env_BioSAK/bin/activate
       BioSAK -h
              
       # Type "deactivate" in your terminal to leave Python's virtual environment.

+ Dependencies: bowtie2 and samtools

      BioSAK reads2bam -ref ref.fa -r1 R1.fq -r2 R1.fq -fq -index -t 12
      BioSAK reads2bam -ref ref.fa -r1 R1.fa -r2 R1.fa -up unpaired.fa -index -t 12
      BioSAK reads2bam -ref ref.fa -up unpaired.fa -index -local -t 12 -tmp
      BioSAK reads2bam -ref ref.fa -up unpaired_R1.fa,unpaired_R2.fa -index -t 12 -tmp

### Dataset types

+ ColorStrip https://itol.embl.de/help.cgi#strip

      BioSAK iTOL -ColorStrip -lg MagTaxon.txt -lt Phylum -o ColorStrip_taxon.txt

+ ColorRange https://itol.embl.de/help.cgi#dsRanges

      BioSAK iTOL -ColorRange -lg MagTaxon.txt -lt Phylum -o ColorRange_taxon.txt
      BioSAK iTOL -ColorRange -taxon Taxonomy.txt -rank f -lt Family -o ColorRange_taxon.txt

+ SimpleBar https://itol.embl.de/help.cgi#bar

      BioSAK iTOL -SimpleBar -lv MagSize.txt -scale 0-3-6-9 -lt Size -o SimpleBar_size.txt

+ Heatmap https://itol.embl.de/help.cgi#heatmap

      BioSAK iTOL -Heatmap -lm MagAbundance.txt -lt Abundance -o Heatmap_abundance.txt

+ Binary https://itol.embl.de/help.cgi#binary

      BioSAK iTOL -Binary -lm Binary_matrix.txt -lt Presence_Absence -gc lightblue -o PA_iTOL.txt
      BioSAK iTOL -Binary -lm Binary_matrix.txt -lt Presence_Absence -gc "#85C1E9" -o PA_iTOL.txt

+ ExternalShape https://itol.embl.de/help.cgi#shapes

      BioSAK iTOL -ExternalShape -lm identity_matrix.txt -lt Identity -scale 25-50-75-100 -o ExternalShape_identity.txt


### Input file format

+ Leaf-to-Group (`-lg`, tab separated, no header)

      genome_1  Bacteria
      genome_2  Archaea

+ Taxonomy (`-taxon`, tab separated, GTDB-format taxononomy string)

      genome_1	d__Bacteria;p__Proteobacteria;c__Alphaproteobacteria;o__Dongiales;f__Dongiaceae;g__Dongia;s__Dongia mobilis
      genome_2	d__Bacteria;p__Proteobacteria;c__Gammaproteobacteria;o__Arenicellales;f__LS-SOB;g__VYGS01;s__

+ Group-to-Color (`-gc`) and Column-to-Color (`-cc`) (tab separated, no header)

      Bacteria    #CCCC00
      Archaea #9999FF
      Virus   orange
      Eukaryote   lightblue

  -Please note that only one color can be specified for Binary data, provide with `-gc lightblue` or `-gc "#85C1E9"`


+ Leaf-to-Value file format (`-lv`, tab separated, no header)

      genome_1	6.15
      genome_2	6.63

+ Leaf-to-Matrix file format (`-lm`, tab separated, header required!!!)

      Genome_id Sample_A   Sample_B   Sample_C
      genome_1	6.15    2.23    1.56
      genome_2	6.63    1.72    2.55


## Here is a tutorial

1. Here, I have a phylogenetic tree for 37 MAGs derived from six microbial communities (either surface-associated or planktonic).
I have the taxonomy info of these MAGs at the class level, their sizes and their relative abundance across the six samples.
This short note shows how to visualize all these info in one plot.

1. Download files from [demo_data/iTOL](../demo_data/iTOL)

1. File description (Please see below for how to prepare these files.):

    + A phylogenetic tree in [Newick](http://evolution.genetics.washington.edu/phylip/newicktree.html) format: [NorthSea_0_Tree.newick](files_needed/NorthSea_0_Tree.newick)
    + Taxonomy info: [NorthSea_1_Taxon_ColorStrip.txt](files_needed/NorthSea_1_Taxon_ColorStrip.txt), [NorthSea_1_Taxon_Range.txt](files_needed/NorthSea_1_Taxon_Range.txt)
    + Life-style info: [NorthSea_2_LifeStyle.txt](files_needed/NorthSea_2_LifeStyle.txt)
    + Abundance across samples: [NorthSea_3_Abundance.txt](files_needed/NorthSea_3_Abundance.txt)
    + MAG size info: [NorthSea_4_MAG_Size.txt](files_needed/NorthSea_4_MAG_Size.txt)

1. Upload **NorthSea_0_Tree.newick** to iTOL via [https://itol.embl.de/upload.cgi](https://itol.embl.de/upload.cgi).

1. Once you have the tree uploaded, you'll see the skeleton of the tree without any decoration. 
You can now play around with the control panel on the right side (e.g. change tree layout to circular).
![Step_1](figures/Step_1.jpg)

1. We are going to add the taxonomy info of our MAG to the tree now, which is really easy to do in iTOL. 
You just need to drag and drop **NorthSea_1_Taxon_ColorStrip.txt**  to the **tree area**.

1. Do the same thing to **NorthSea_2_LifeStyle.txt**, **NorthSea_3_Abundance.txt** and **NorthSea_4_MAG_Size.txt** to add life-style, abundance and size info, 
you'll see trees like this:
![Tree_1](figures/Tree_1.jpg)

1. To get a tree with a circular layout and MAG classes coloured as in the figure below. 
You need to use **NorthSea_1_Taxon_Range.txt** instead of **NorthSea_1_Taxon_ColorStrip.txt**,
choose "**Circular**" mode in the control panel, click "**At tips**" and then turn it **off**.
![Tree_2](figures/Tree_2.jpg)

1. Go to the **Export** panel, choose desired file format and export your tree to file. 
Remember to turn on **Colored ranges legend**, if you are using **NorthSea_1_Taxon_Range.txt** to color MAG classes.
![Step_2](figures/Step_2.jpg)


## How to prepare iTOL-recognizable files

1. Some tools suggested by iTOL: https://itol.embl.de/help.cgi#external

2. You can also use [BioSAK](https://github.com/songweizhi/BioSAK)'s iTOL module to generate iTOL-recognizable files. Please refers to the "Installation" section [here](https://github.com/songweizhi/BioSAK) for its installation.
    
  The purpose for developing this module is to generate iTOL-recognizable file for your dataset, 
  parameters (e.g., colour, font size...) provided in the generated file might need 
  further adjustment.
  
  Input files for the following commands can be found in `files_needed/raw_data`.
     
      BioSAK iTOL -ColorRange -lg raw_MAG_taxon.txt -lt Class -out NorthSea_1_Taxon_Range.txt
      BioSAK iTOL -ColorStrip -lg raw_MAG_taxon.txt -lt Class -out NorthSea_1_Taxon_ColorStrip.txt
      BioSAK iTOL -ColorStrip -lg raw_MAG_LifeStyle.txt -lt LifeStyle -out NorthSea_2_LifeStyle.txt
      BioSAK iTOL -Heatmap -lm raw_MAG_abundance.txt -lt Abundance -out NorthSea_3_Abundance.txt
      BioSAK iTOL -SimpleBar -lv raw_MAG_size.txt -scale 0-3-6-9 -lt MAG_Size -out NorthSea_4_MAG_Size.txt
      
      # for help
      BioSAK iTOL -h


## Help information

1. More examples: [https://itol.embl.de/help.cgi](https://itol.embl.de/help.cgi)
1. The Newick tree format: [http://evolution.genetics.washington.edu/phylip/newicktree.html](http://evolution.genetics.washington.edu/phylip/newicktree.html)
1. Hex Color Codes: [https://htmlcolorcodes.com](https://htmlcolorcodes.com) and [https://www.color-hex.com](https://www.color-hex.com)

帮助
---

### Functional annotation

+ __[KEGG](KEGG_cn.md)__                   			    - 使用 KEGG 数据库进行功能注释
+ __[COG2020](COG2020_cn.md)__                			- 使用 COG 数据库进行功能注释 (v2020)
+ __[arCOG](arCOG_cn.md)__                  			- 使用 arCOG 数据库进行功能注释 (ar18)
+ __[dbCAN](dbCAN_cn.md)__                  			- 使用 CAZy 数据库进行功能注释 (需要调用dbCAN)

### Metagenomics

+ __[CheckM](CheckM_cn.md)__                     	    - 解析 CheckM 输出结果
+ __[magabund](magabund_cn.md)__               		    - Calculate MAG abundance
+ __[mean_MAG_cov](mean_MAG_cov_cn.md)__           	    - Get mean MAG depth (based on MetaBAT produced depth)
+ __[RunGraphMB](RunGraphMB_cn.md)__             		- Prepare input files for GraphMB
+ __[get_MAG_reads_long](get_MAG_reads_long_cn.md)__    - Extract MAG-specific long reads for reassembling
+ __[get_gnm_size](get_gnm_size_cn.md)__           	    - Get the total length of genome(s)
+ __[get_gene_depth](get_gene_depth_cn.md)__         	- Get gene depth by contig depth
+ __[MeanMappingDepth](MeanMappingDepth_cn.md)__        - Get mean mapping depth 
+ __[Plot_MAG](Plot_MAG_cn.md)__               		    - plot MAGs, (GC vs depth)

### Genome databases

+ __[get_GTDB_taxon_gnm](get_GTDB_taxon_gnm_cn.md)__ 	- Get id of genomes from specified GTDB taxons
+ __[get_genome_GTDB](get_genome_GTDB_cn.md)__        	- Batch download GTDB genomes
+ __[get_genome_NCBI](get_genome_NCBI_cn.md)__        	- Batch download GenBank genomes
+ __[sampling_GTDB_gnms](sampling_GTDB_gnms_cn.md)__    - Select GTDB genomes from a specified taxon at specified sampling rank
+ __[subset_GTDB_meta](subset_GTDB_meta_cn.md)__        - Subset metadata of GTDB reference genomes

### 16S rRNA related

+ __[top_16S_hits](top_16S_hits_cn.md)__           	    - Classify 16S by top-blast-hits approach
+ __[SILVA_for_BLCA](SILVA_for_BLCA_cn.md)__        	- Prepare BLCA-compatible SILVA SSU database
+ __[GTDB_for_BLCA](GTDB_for_BLCA_cn.md)__          	- Prepare BLCA-compatible GTDB SSU database
+ __[BLCA_op_parser](BLCA_op_parser_cn.md)__         	- Make the BLCA outputs bit easier to read
+ __[Tax4Fun2IndOTU](Tax4Fun2IndOTU_cn.md)__         	- Get functional profile of individual OTUs (to be added)

### Sequence/Alignment manipulator

+ __[gbk2fa/gbk2faa/gbk2ffn](_cn.md)__ 				    - Format convertors
+ __[ffn2faa/gfa2fa/get_rc](_cn.md)__  				    - Format convertors
+ __[fq2fa](fq2fa_cn.md)__                  			- Convert fastq to fasta
+ __[fa2id](fa2id_cn.md)__                  			- Export sequence id
+ __[slice_seq](slice_seq_cn.md)__              		- Get specified region of a sequence
+ __[rename_seq](rename_seq_cn.md)__            	 	- Rename sequences in a file
+ __[select_seq](select_seq_cn.md)__             		- Select sequences by their ids
+ __[split_fasta](split_fasta_cn.md)__            		- Split one fasta file into multiple files
+ __[merge_seq](merge_seq_cn.md)__              		- Merge sequence files, remove duplicated ones if any
+ __[cat_fa](cat_fa_cn.md)__                 			- Combine sequence files, prefix sequence id with file name

### Sam/Bam

+ __[plot_sam_depth](plot_sam_depth_cn.md)__         	- Plot SAM depth
+ __[reads2bam](reads2bam_cn.md)__              		- Mapping and sorting
+ __[sam2bam](sam2bam_cn.md)__                			- Sam to BAM with samtools
+ __[split_sam](split_sam_cn.md)__              		- Split SAM/BAM file by reference
+ __[bam2reads](bam2reads_cn.md)__              		- Extract reads (id) from sam file

### Others

+ __[iTOL](iTOL_cn.md)__                   			    - Prepare iTOL-compatible files for tree visualization
+ __[js_cmds](js_cmds_cn.md)__                			- Commands to job scripts
+ __[exe_cmds](exe_cmds_cn.md)__               		    - Execute commands with multiprocessing (one cmd per line)
+ __[BestHit](BestHit_cn.md)__                			- Keep best blast hits (outfmt 6)
+ __[VisGeneFlk](VisGeneFlk_cn.md)__             		- Visualize gene flanking regions
+ __[split_folder](split_folder_cn.md)__           	    - Split folder
+ __[usearch_uc](usearch_uc_cn.md)__             		- Parse Usearch uc file
+ __[get_Pfam_hmms](get_Pfam_hmms_cn.md)__          	- Get Pfam profiles by id
+ __[Reads_simulator](Reads_simulator_cn.md)__        	- Simulate NGS reads
+ __[SubsampleLongReads](SubsampleLongReads_cn.md)__    - Subsample Long Reads
+ __[rename_reads_Reago](rename_reads_Reago_cn.md)__    - Rename paired reads for Reago
+ __[cross_link_seqs](cross_link_seqs_cn.md)__        	- Cross link matched regions between two sequences (not working well!)

### Note

Phylogenetic tree-related modules have been moved to TreeSAK, please go to its github page for details.

+ Example commands

      BioSAK get_GTDB_taxon_gnm -p Bac -meta bac120_metadata_r202.tsv -path genome_paths.tsv -taxon taxons.txt -cpl 85 -ctm 5
      BioSAK get_GTDB_taxon_gnm -p Arc -meta ar122_metadata_r202.tsv -path genome_paths.tsv -taxon taxons.txt -cpl 50 -ctm 10

+ -meta: bac120_metadata_r202.tsv or ar122_metadata_r202.tsv

+ -path: genome_paths.tsv, in fastani folder from auxillary_files

+ -taxon: one taxon per line, example below:

      p__Thermoproteota
      c__Methanosarcinia
      f__Thalassarchaeaceae

# Extract sequences with provided id
BioSAK select_seq -seq ctg.fasta -id seq_id.txt -out output.1.fa -option 1 
BioSAK select_seq -seq reads.fastq -id read_id.txt -out output.1.fq -option 1 -fq

# Extract sequences except those in seq_id.txt
BioSAK select_seq -seq ctg.fasta -id seq_id.txt -out output.0.fa -option 0
BioSAK select_seq -seq ctg.fasta -id seq_id.txt -out output.0.fa -option 0 -oneline

# seq_id.txt file format: one id per line, great than symbol excluded.

    module load samtools/1.15
    BioSAK split_sam -p single_ctg -i input.bam -r contig_1 -t 12
    BioSAK split_sam -p multi_ctgs -i input.bam -r ctgs.txt -t 12

# Output files:
    prefix.sam, prefix_sorted.bam and prefix_sorted.bam.bai

# ctgs.txt file format: one id per line, ">" excluded.

# Get gene depth by contig depth, together with gbk or gff (prefered) file
BioSAK get_gene_depth -gff test.gff -ctg_depth contig_depth.txt
BioSAK get_gene_depth -gff test.gff -ctg_depth contig_depth.txt -skip_header
BioSAK get_gene_depth -gbk test.gbk -ctg_depth contig_depth.txt -skip_header

# Contig depth file format (one contig per line, tab separated)
contig_1    30.16
contig_2    26
contig_3    0.726

Help information for BioSAK modules
---


### Functional annotation

+ __[KEGG](KEGG.md)__                   			- KEGG annotation
+ __[COG2020](COG2020.md)__                			- COG annotation (v2020, by blastp/diamond)
+ __[arCOG](arCOG.md)__                  			- COG annotation for archaea (version ar18)
+ __[dbCAN](dbCAN.md)__                  			- CAZy annotation with dbCAN 
+ __[CheckM](CheckM.md)__                 			- Parse CheckM outputs

### Metagenomics

+ __[magabund](magabund.md)__               		- Calculate MAG abundance
+ __[mean_MAG_cov](mean_MAG_cov.md)__           	- Get mean MAG depth (based on MetaBAT produced depth)
+ __[RunGraphMB](RunGraphMB.md)__             		- Prepare input files for GraphMB
+ __[get_MAG_reads_long](get_MAG_reads_long.md)__   - Extract MAG-specific long reads for reassembling
+ __[get_gnm_size](get_gnm_size.md)__           	- Get the total length of genome(s)
+ __[get_gene_depth](get_gene_depth.md)__         	- Get gene depth by contig depth
+ __[MeanMappingDepth](MeanMappingDepth.md)__       - Get mean mapping depth 
+ __[Plot_MAG](Plot_MAG.md)__               		- plot MAGs, (GC vs depth)

### Genome databases

+ __[get_GTDB_taxon_gnm](get_GTDB_taxon_gnm.md)__ 	- Get id of genomes from specified GTDB taxons
+ __[get_genome_GTDB](get_genome_GTDB.md)__        	- Batch download GTDB genomes
+ __[get_genome_NCBI](get_genome_NCBI.md)__        	- Batch download GenBank genomes
+ __[sampling_GTDB_gnms](sampling_GTDB_gnms.md)__   - Select GTDB genomes from a specified taxon at specified sampling rank
+ __[subset_GTDB_meta](subset_GTDB_meta.md)__       - Subset metadata of GTDB reference genomes

### 16S rRNA related

+ __[top_16S_hits](top_16S_hits.md)__           	- Classify 16S by top-blast-hits approach
+ __[SILVA_for_BLCA](SILVA_for_BLCA.md)__        	- Prepare BLCA-compatible SILVA SSU database
+ __[GTDB_for_BLCA](GTDB_for_BLCA.md)__          	- Prepare BLCA-compatible GTDB SSU database
+ __[BLCA_op_parser](BLCA_op_parser.md)__         	- Make the BLCA outputs bit easier to read
+ __[Tax4Fun2IndOTU](Tax4Fun2IndOTU.md)__         	- Get functional profile of individual OTUs (to be added)

### Sequence/Alignment manipulator

+ __[gbk2fa](gbk2fa.md)__ 				 			- Format convertors: gbk2fa
+ __[gbk2faa](gbk2faa.md)__ 						- Format convertors: gbk2faa
+ __[gbk2ffn](gbk2ffn.md)__ 						- Format convertors: gbk2ffn
+ __[ffn2faa](ffn2faa.md)__  						- Format convertors: ffn2faa
+ __[gfa2fa](gfa2fa.md)__  				 			- Format convertors: gfa2fa
+ __[get_rc](get_rc.md)__  				 			- Format convertors: get_rc
+ __[fq2fa](fq2fa.md)__                  			- Convert fastq to fasta
+ __[fa2id](fa2id.md)__                  			- Export sequence id
+ __[slice_seq](slice_seq.md)__              		- Get specified region of a sequence
+ __[rename_seq](rename_seq.md)__            	 	- Rename sequences in a file
+ __[select_seq](select_seq.md)__             		- Select sequences by their ids
+ __[split_fasta](split_fasta.md)__            		- Split one fasta file into multiple files
+ __[merge_seq](merge_seq.md)__              		- Merge sequence files, remove duplicated ones if any
+ __[cat_fa](cat_fa.md)__                 			- Combine sequence files, prefix sequence id with file name

### Sam/Bam

+ __[plot_sam_depth](plot_sam_depth.md)__         	- Plot SAM depth
+ __[reads2bam](reads2bam.md)__              		- Mapping and sorting
+ __[sam2bam](sam2bam.md)__                			- Sam to BAM with samtools
+ __[split_sam](split_sam.md)__              		- Split SAM/BAM file by reference
+ __[bam2reads](bam2reads.md)__              		- Extract reads (id) from sam file

### Others

+ __[iTOL](iTOL.md)__                   			- Prepare iTOL-compatible files for tree visualization
+ __[js_cmds](js_cmds.md)__                			- Commands to job scripts
+ __[exe_cmds](exe_cmds.md)__               		- Execute commands with multiprocessing (one cmd per line)
+ __[BestHit](BestHit.md)__                			- Keep best blast hits (outfmt 6)
+ __[VisGeneFlk](VisGeneFlk.md)__             		- Visualize gene flanking regions
+ __[split_folder](split_folder.md)__           	- Split folder
+ __[usearch_uc](usearch_uc.md)__             		- Parse Usearch uc file
+ __[get_Pfam_hmms](get_Pfam_hmms.md)__          	- Get Pfam profiles by id
+ __[Reads_simulator](Reads_simulator.md)__        	- Simulate NGS reads
+ __[SubsampleLongReads](SubsampleLongReads.md)__   - Subsample Long Reads
+ __[rename_reads_Reago](rename_reads_Reago.md)__   - Rename paired reads for Reago
+ __[cross_link_seqs](cross_link_seqs.md)__        	- Cross link matched regions between two sequences (not working well!)

### Note

Phylogenetic tree-related modules have been moved to TreeSAK, please go to its github page for details.

+ Example commands

      BioSAK sampling_GTDB_gnms -p Firm_o -meta bac120_metadata_r207.tsv -taxon p__Firmicutes -r o
      BioSAK sampling_GTDB_gnms -p Firm_f -meta bac120_metadata_r207.tsv -taxon p__Firmicutes -r f -cpl 85 -ctm 5 -rs
      BioSAK sampling_GTDB_gnms -p Firm_g -meta bac120_metadata_r207.tsv -taxon p__Firmicutes -r g -cpl 85 -ctm 5 -ts

+ -meta: bac120_metadata_r207.tsv or ar122_metadata_r207.tsv
+ Sampling rank need to be lower than the rank of specified taxon (-taxon).
+ Genome(s) with highest quality score(s)(defined as completeness-5*contamination) will be selected.

### Badge examples
[![github repo-size](https://img.shields.io/github/followers/songweizhi.svg?label=Follow)]()
[![github repo-size](https://img.shields.io/github/forks/songweizhi/Binning_refiner.svg?label=Fork)]()
[![github repo-size](https://img.shields.io/github/stars/songweizhi/Binning_refiner.svg)]()
[![github repo-size](https://img.shields.io/github/stars/songweizhi/Binning_refiner.svg?style=social)]()
[![github repo-size](https://img.shields.io/github/watchers/songweizhi/Binning_refiner.svg?label=Watch)]()
[![github issues](https://img.shields.io/github/issues/songweizhi/Binning_refiner.svg)]()
[![DOI](https://img.shields.io/static/v1.svg?label=DOI&message=10.1093/bioinformatics/btx086&color=orange)](https://doi.org/10.1093/bioinformatics/btx086)


Some examples of Markdown syntax
---

https://confluence.atlassian.com/bitbucketserver/markdown-syntax-guide-776639995.html#Markdownsyntaxguide-Markdownsyntax

http://daringfireball.net/projects/markdown/syntax

# This is an H1
## This is an H2
### This is an H3
#### This is an H4
##### This is an H5
###### This is an H6

*This is an Italic characters*

_This is also an Italic characters_

**This is a bold characters**

__This is also a bold characters__

~~strikethrough~~

* Item 1
  * Item 1.1
    * Item 1.1.1


1. Step 1
   1. Step 1.1
        1. Step 1.1.1

Introducing my quote:
> This is the first level of quoting.
>
>> This is nested blockquote.
>
> Back to the first level.


Use the backtick to refer to a `function()`. There is a literal ``backtick (`)`` here.


This is [an example](http://www.example.com/) inline link.

[This link](http://example.com/ "Title") has a title attribute.

Links are also auto-detected in text: http://example.com/

| Day     | Meal    | Price |
| --------|---------|-------|
| Monday  | pasta   | $6    |
| Tuesday | chicken | $8    |

+ Rename "NODE_941_length_17600_cov_52.7123" to "NODE_941"

      BioSAK rename_seq -in Contigs.fa -sep_in "_" -n 2

+ Rename "Seawater|NODE|941|length|17600|cov|52.7123" to "Seawater_NODE_941"

      BioSAK rename_seq -in Contigs.fa -sep_in "|" -sep_out "_" -n 3

+ Add prefix to all sequences in a fasta file

      BioSAK rename_seq -in Contigs.fa -prefix seawater

+ Rename "NODE_941_length_17600_cov_52.7123" to "Seawater_NODE_941"

      BioSAK rename_seq -in Contigs.fa -sep_in "_" -n 2 -prefix Seawater

+ Rename sequences in multiple files

      BioSAK rename_seq -in seq_folder -x fa -sep_in "_" -n 2 -t 12
      BioSAK rename_seq -in seq_folder -x fa -prefix prefix_file.txt

+ Prefix file format: sequence file name (with extension) followed by prefixed to be added, tab separated, one file per line
  
      genome_1.fa prefix_1
      genome_1.fa prefix_2
      genome_1.fa prefix_3

### Dependencies: 
  + blast+, 
  + diamond


### Prepare DB files:

    cd path/to/your/arCOG_db_dir
    wget https://ftp.ncbi.nih.gov/pub/wolf/COGs/arCOG/tmp.ar18/ar18.fa.gz
    wget https://ftp.ncbi.nih.gov/pub/wolf/COGs/arCOG/tmp.ar18/ar18.ar14.02.csv
    wget https://ftp.ncbi.nih.gov/pub/wolf/COGs/arCOG/tmp.ar18/arCOG_names_220807.txt
    wget https://ftp.ncbi.nih.gov/pub/COG/COG2020/data/fun-20.tab
    gunzip ar18.fa.gz
    makeblastdb -in ar18.fa -dbtype prot -parse_seqids -logfile ar18.fa.log
    diamond makedb --in ar18.fa --db ar18.fa.dmnd --quiet

### Annotate protein sequences

    BioSAK arCOG -m P -t 6 -db_dir /Users/songweizhi/DB/arCOG18 -i genes.faa 
    BioSAK arCOG -m P -t 6 -db_dir /Users/songweizhi/DB/arCOG18 -i faa_files -x faa -depth depth_files

### Annotate DNA sequences (ORFs)

    BioSAK arCOG -m N -t 6 -db_dir /Users/songweizhi/DB/arCOG18 -i genes.ffn -depth gene.depth
    BioSAK arCOG -m N -t 6 -db_dir /Users/songweizhi/DB/arCOG18 -i ffn_files -x ffn

+ For how it works, please refers to the help information of the COG2020 module (BioSAK COG2020 -h)

# example command 

    BioSAK magabund -s all_bins.sam -m all_bins -x fa -o output.txt

# Note
The input sam file is obtained by mapping quality-filtered reads to the assemblies 
derived from these reads. 

### Usage:

+ Before you start, you need to get the [prokaryotes.txt](https://ftp.ncbi.nlm.nih.gov/genomes/GENOME_REPORTS/prokaryotes.txt) from NCBI  
and provide it to `get_genome_NCBI` with `-db prokaryotes.txt`.

### Download genomes
    BioSAK get_genome_NCBI -db prokaryotes.txt -out gnm_dir -id gnms_to_download.txt -t 8 -fna
    BioSAK get_genome_NCBI -db prokaryotes.txt -out gnm_dir -id gnms_to_download.txt -t 8 -fna -faa -name

### Format of input file

+ gnms_to_download.txt (genome ID can be found in the "Assembly Accession" column of the prokaryotes.txt)

      GCA_009840555.1
      GCA_009840575.1


### You can get the id of genomes from a specific taxon using this link, IDs are in the "Assembly" column.
https://www.ncbi.nlm.nih.gov/genome/browse#!/prokaryotes/refseq_category:reference

module load samtools/1.15

    BioSAK bam2reads -b sorted.bam -o bam2reads_wd_ctg1 -r ctg_1
    BioSAK bam2reads -b sorted.bam -o bam2reads_wd_ctg2 -r ctg_2:200-5000
    BioSAK bam2reads -b sorted.bam -o bam2reads_wd_ctg3 -r ctg_3:200-
    BioSAK bam2reads -b sorted.bam -o bam2reads_wd_ctg4 -r ctg_4:-500 -s reads.fastq

    % BioSAK -h

                        ...::: BioSAK :::...

    Genome databases
       get_GTDB_taxon_gnm      ->  Get id of genomes from specified GTDB taxons
       get_genome_GTDB         ->  Batch download GTDB genomes
       get_genome_NCBI         ->  Batch download GenBank genomes
       sampling_GTDB_gnms      ->  Select GTDB genomes from a specified taxon at specified sampling rank
       subset_GTDB_meta        ->  Subset metadata of GTDB reference genomes

    Metagenomics
       Plot_MAG                ->  plot MAGs, (GC vs depth)
       magabund                ->  Calculate MAG abundance
       mean_MAG_cov            ->  Get mean MAG depth (based on MetaBAT produced depth)
       RunGraphMB              ->  Prepare input files for GraphMB
       get_MAG_reads_long      ->  Extract MAG-specific long reads for reassembling
       get_gnm_size            ->  Get the total length of genome(s)
       get_gene_depth          ->  Get gene depth by contig depth
       MeanMappingDepth        ->  Get mean mapping depth 
       CheckM                  ->  Parse CheckM outputs

    Functional annotation
       KEGG                    ->  KEGG annotation
       COG2020                 ->  COG annotation (v2020, by blastp/diamond)
       arCOG                   ->  COG annotation for archaea (version ar18)
       dbCAN                   ->  CAZy annotation with dbCAN

    16S rRNA related
       top_16S_hits            ->  Classify 16S by top-blast-hits approach
       SILVA_for_BLCA          ->  Prepare BLCA-compatible SILVA SSU database
       GTDB_for_BLCA           ->  Prepare BLCA-compatible GTDB SSU database
       BLCA_op_parser          ->  Make the BLCA outputs bit easier to read
       Tax4Fun2IndOTU          ->  Get functional profile of individual OTUs (to be added)
    
    Sequence manipulator
       gbk2fna/gbk2faa/gbk2ffn ->  Format convertors
       ffn2faa/gfa2fa/get_rc   ->  Format convertors
       fq2fa                   ->  Convert fastq to fasta
       fa2id                   ->  Export sequence id
       slice_seq               ->  Get specified region of a sequence
       rename_seq              ->  Rename sequences in a file
       select_seq              ->  Select sequences by their ids
       split_fasta             ->  Split one fasta file into multiple files
       merge_seq               ->  Merge sequence files, remove duplicated ones if any
       cat_fa                  ->  Combine sequence files, prefix sequence id with file name
    
    Multiple Sequence Alignment
       ConvertMSA             ->  Convert MSA format
       fa2phy                 ->  Convert MSA format (fasta to phylip)
       OneLineAln             ->  One-line fasta format alignments
       SliceMSA               ->  Slice MSA by column 
       
    Sam and Bam
       plot_sam_depth          ->  Plot SAM depth
       reads2bam               ->  Mapping and sorting
       sam2bam                 ->  Sam to BAM with samtools
       split_sam               ->  Split SAM/BAM file by reference
       bam2reads               ->  Extract reads (id) from sam file
    
    Others
       iTOL                    ->  Prepare iTOL-compatible files for tree visualization
       js_cmds                 ->  Commands to job scripts
       exe_cmds                ->  Execute commands with multiprocessing (one cmd per line)
       BestHit                 ->  Keep best blast hits (outfmt 6)
       VisGeneFlk              ->  Visualize gene flanking regions
       split_folder            ->  Split folder
       usearch_uc              ->  Parse Usearch uc file
       get_Pfam_hmms           ->  Get Pfam profiles by id
       Reads_simulator         ->  Simulate NGS reads
       SubsampleLongReads      ->  Subsample Long Reads
       rename_reads_Reago      ->  Rename paired reads for Reago
       cross_link_seqs         ->  Cross link matched regions between two sequences (not working well!)
       
    Phylogenetic tree-related modules have been moved to TreeSAK, please go to its github page for details.

    module load blast+/2.9.0
    BioSAK top_16S_hits -p 16S_vs_GTDB -q 16S_sequences.fa -r GTDB_ssu_all_r95.fna -t 6
    BioSAK top_16S_hits -p 16S_vs_SILVA -q 16S_sequences.fa -r SILVA_138_SSURef_NR99_tax_silva.fasta -t 6 -top 5

# prepare GTDB SSU database file
    wget https://data.gtdb.ecogenomic.org/releases/release95/95.0/genomic_files_all/ssu_all_r95.tar.gz
    tar xvzf ssu_all_r95.tar.gz
    makeblastdb -in GTDB_ssu_all_r95.fna -dbtype nucl -parse_seqids -logfile /dev/null

# prepare SILVA SSU database file
    wget https://www.arb-silva.de/fileadmin/silva_databases/release_138/Exports/SILVA_138_SSURef_NR99_tax_silva.fasta.gz
    gunzip SILVA_138_SSURef_NR99_tax_silva.fasta.gz
    makeblastdb -in SILVA_138_SSURef_NR99_tax_silva.fasta -dbtype nucl -parse_seqids -logfile /dev/null

BioSAK get_MAG_reads_long -r LongReads.fastq -s assembly.sam -m MAG_1.fa -o MAG_1_reads
BioSAK get_MAG_reads_long -r LongReads.fastq -s assembly.sam -m MAG_dir -x fa -o extracted_reads -l 0
BioSAK get_MAG_reads_long -r LongReads.fastq -s assembly.sam -m MAG_dir -x fa -o extracted_reads -l 5000

# Note
1. The input sam file is obtained by mapping quality-filtered reads to all (not a subset of) contigs derived 
   from these reads (e.g., flye produced assembly.fasta).
2. The input MAGs and Sam file need to be generated from the same set of contigs (without renaming).
3. If one read was mapped to multiple contigs from different MAGs, this read will be exported to the extracted 
   reads of all the above MAGs.
4. If you use minimap2 for reads mapping, you might want to specify "--secondary=no" to minimise low-quality 
   secondary alignments:
   minimap2 -d assembly.fasta.mmi assembly.fasta
   minimap2 --secondary=no -t 6 -a assembly.fasta.mmi long_reads.fastq > assembly.sam

+ only parse quality file

      BioSAK CheckM -i checkm_op.txt -o MAG_qualities.txt
      BioSAK CheckM -i checkm_op.txt -o MAG_qualities.txt -r

+ get the quality of qualified bins 

      BioSAK CheckM -i checkm_op.txt -cpl 99 -o MAG_qualities_cpl99.txt
      BioSAK CheckM -i checkm_op.txt -cpl 99 -ctm 5 -o MAG_qualities_cpl99_ctm5.txt

+ get the quality of qualified MAG and copy them into a separate folder

      BioSAK CheckM -i checkm_op.txt -g MAG_folder -x fa -cpl 99 -o MAG_qualities_cpl99.txt
      BioSAK CheckM -i checkm_op.txt -g MAG_folder -x fa -cpl 99 -ctm 5 -o MAG_qualities_cpl99_ctm5.txt

+ Note
adjusted_contamination = contamination x (100 - heterogeneity) / 100

BioSAK slice_seq -in idba.fa -id ctg_01 -range 20-400 -out ctg1_20_400bp.fa
BioSAK slice_seq -in idba.fa -id ctg_01 -range 1-50 -out ctg1_1_50bp.fa -rc
BioSAK slice_seq -in idba.fa -id ctg_01 -range 30-end -out ctg1_30bp_to_end.fa

# Example commands
    BioSAK get_genome_GTDB -id genome.txt -path genome_paths.tsv -dir release202/fastani -out op_gnm_folder

# -dir: the folder which hold genome_paths.tsv
# genome paths: in the fastani folder from GTDB auxillary_files
# example of genome id file (one id per line):
GCA_902608175.1
GCA_903901015.1
GCF_000007225.1

    BioSAK subset_GTDB_meta -meta ar122_metadata_r202.tsv -id gnm_id.txt -out metadata_subset.txt
    BioSAK subset_GTDB_meta -meta bac120_metadata_r202.tsv -id gnm_id.txt -out metadata_subset.txt

# format of gnm_id.txt (one id per line)
GCA_002726655.1
GCA_002728675.1
